	.module External_Converters.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\External_Converters.c
	.dbfunc e error _error fI
;            err -> R16,R17
	.even
_error::
	.dbline -1
	.dbline 59
; /**************************************************************
;  *
;  *  Program Title:  Wasp AVR Monitor
;  *  
;  *  Program Name:  External_Converters.c	  Version: 0.01
;  *  
;  *  Author:  BR	  					  Date:  March 26, 2008
;  *  
;  *  Compiled with ImageCraft ICCAVR Standard V7.02
;  *  
;  *  This modual provides functions to control the ADS1110 and the DAC8501
;  *  These devices are not placed on the WASP by default so they may not be
;  *  available to you.  They may however be soldered onto the board if required.
;  *
;  * Copyright 2008, SOC ROBOTICS, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; 
; #include <iom644v.h>
; #include "External_Converters.h"
; 
; 
; unsigned char old_DDR;
; 
; /*
;  *Error Function
;  */
; int error(int err)
; {
	.dbline 60
;  	return err;
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r err 16 I
	.dbend
	.dbfunc e InitI2CADC _InitI2CADC fI
;        control -> R10
	.even
_InitI2CADC::
	st -y,R10
	st -y,R11
	mov R10,R16
	.dbline -1
	.dbline 70
; }
; 
; 
; /*
;  *Sends a control byte to the ADS1110.
;  *If the ADC is not connected or if there
;  *is an issue interfacing, -1 will be returned
;  */
; int InitI2CADC(unsigned char control)
; {
	.dbline 72
;  	//setting the SCK to ~100k
;  	TWBR = 2;
	ldi R24,2
	sts 184,R24
	.dbline 75
; 		
; 	//Send a start condition
;  	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	ldi R24,164
	sts 188,R24
L3:
	.dbline 77
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L4:
	.dbline 77
	lds R2,188
	sbrs R2,7
	rjmp L3
X0:
	.dbline 79
; 	//ensure no error
; 	if ((TWSR & 0xF8) != 0x08)//start was good
	lds R24,185
	andi R24,248
	cpi R24,8
	breq L6
X1:
	.dbline 80
; 	   return error(-1);
	ldi R16,-1
	ldi R17,-1
	xcall _error
	xjmp L2
L6:
	.dbline 83
; 	   
; 	//send slave address and say we are writing to it
; 	TWDR = (ADC_ADDRESS<<1);//SLA_W;
	ldi R24,146
	sts 187,R24
	.dbline 84
; 	TWCR = (1<<TWINT) | (1<<TWEN);
	ldi R24,132
	sts 188,R24
L8:
	.dbline 87
; 	
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L9:
	.dbline 87
	lds R2,188
	sbrs R2,7
	rjmp L8
X2:
	.dbline 89
; 	
; 	if ((TWSR & 0xF8) != 0x18)//SLA+W has been transmitted
	lds R24,185
	andi R24,248
	cpi R24,24
	breq L11
X3:
	.dbline 90
; 	   return error(-1);
	ldi R16,-1
	ldi R17,-1
	xcall _error
	xjmp L2
L11:
	.dbline 93
; 	
; 	//send data
; 	TWDR = control;
	sts 187,R10
	.dbline 94
; 	TWCR = (1<<TWINT) | (1<<TWEN);
	ldi R24,132
	sts 188,R24
L13:
	.dbline 96
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L14:
	.dbline 96
	lds R2,188
	sbrs R2,7
	rjmp L13
X4:
	.dbline 98
; 	
; 	if ((TWSR & 0xF8) !=0x28)//Data Ack
	lds R24,185
	andi R24,248
	cpi R24,40
	breq L16
X5:
	.dbline 99
; 	   return error(-1);
	ldi R16,-1
	ldi R17,-1
	xcall _error
	movw R10,R16
	xjmp L2
L16:
	.dbline 102
; 	
; 	//Send stop bit.  No need to wait
; 	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	ldi R24,148
	sts 188,R24
	.dbline 104
; 	     
;  	return 0;
	clr R16
	clr R17
	.dbline -2
L2:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r control 10 c
	.dbend
	.dbfunc e ReadI2CADC _ReadI2CADC fI
;           temp -> R10,R11
	.even
_ReadI2CADC::
	xcall push_xgset003C
	.dbline -1
	.dbline 114
; }
; 
; 
; /*
;  *This function will read the ADS1110
;  *If there is an error, it will return the
;  *value of the TWSR register
;  */
; int ReadI2CADC(void)
; {
	.dbline 118
;  	int temp;//will store the read value
; 	
; 	//Send a start condition
;  	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	ldi R24,164
	sts 188,R24
L19:
	.dbline 120
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L20:
	.dbline 120
	lds R2,188
	sbrs R2,7
	rjmp L19
X6:
	.dbline 122
; 	//ensure no error
; 	if ((TWSR & 0xF8) != 0x08)//start was good
	lds R24,185
	andi R24,248
	cpi R24,8
	breq L22
X7:
	.dbline 123
; 	   return error((TWSR & 0xF8));
	lds R16,185
	clr R17
	andi R16,248
	andi R17,0
	xcall _error
	xjmp L18
L22:
	.dbline 126
; 	   
; 	//send slave address and say we are writing to it
; 	TWDR = (ADC_ADDRESS<<1 | 0x01);//SLA_R;
	ldi R24,147
	sts 187,R24
	.dbline 127
; 	TWCR = (1<<TWINT) | (1<<TWEN);
	ldi R24,132
	sts 188,R24
L24:
	.dbline 130
; 	
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L25:
	.dbline 130
	lds R2,188
	sbrs R2,7
	rjmp L24
X8:
	.dbline 133
; 	
; 	
; 	if ((TWSR & 0xF8) != 0x40)//SLA+R has been transmitted
	lds R24,185
	andi R24,248
	cpi R24,64
	breq L27
X9:
	.dbline 134
; 	   return error((TWSR & 0xF8));
	lds R16,185
	clr R17
	andi R16,248
	andi R17,0
	xcall _error
	xjmp L18
L27:
	.dbline 138
; 	
; 	
; 	//read data
; 	TWCR = (1<<TWINT) | (1<<TWEN)| (1<<TWEA);//ACK the data
	ldi R24,196
	sts 188,R24
L29:
	.dbline 140
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L30:
	.dbline 140
	lds R2,188
	sbrs R2,7
	rjmp L29
X10:
	.dbline 142
; 	
; 	if ((TWSR & 0xF8) != 0x50)
	lds R24,185
	andi R24,248
	cpi R24,80
	breq L32
X11:
	.dbline 143
; 	   return error((TWSR & 0xF8));
	lds R16,185
	clr R17
	andi R16,248
	andi R17,0
	xcall _error
	movw R10,R16
	xjmp L18
L32:
	.dbline 145
; 	
; 	temp = (TWDR<<8);//MSB shifted to the correct location
	lds R10,187
	clr R11
	mov R11,R10
	clr R10
	.dbline 147
; 	
; 	TWCR = (1<<TWINT) | (1<<TWEN) | (0<<TWEA);//nACK the data
	ldi R24,132
	sts 188,R24
L34:
	.dbline 149
; 	//Wait till it's done
; 	while (!(TWCR & (1<<TWINT)));
L35:
	.dbline 149
	lds R2,188
	sbrs R2,7
	rjmp L34
X12:
	.dbline 151
; 	
; 	if ((TWSR & 0xF8) != 0x58)
	lds R24,185
	andi R24,248
	cpi R24,88
	breq L37
X13:
	.dbline 152
; 	   return error((TWSR & 0xF8));
	lds R16,185
	clr R17
	andi R16,248
	andi R17,0
	xcall _error
	movw R12,R16
	xjmp L18
L37:
	.dbline 154
; 	//Add on the LSB
; 	temp +=TWDR;
	lds R2,187
	clr R3
	add R10,R2
	adc R11,R3
	.dbline 158
; 	
; 
; 	//Send stop bit.  No need to wait
; 	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	ldi R24,148
	sts 188,R24
	.dbline 160
; 	     	
; 	return temp;
	movw R16,R10
	.dbline -2
L18:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r temp 10 I
	.dbend
	.dbfunc e InitDAC _InitDAC fV
	.even
_InitDAC::
	.dbline -1
	.dbline 168
; }
; 
; 
; /*
;  *Set up the DAC8501
;  */
; void InitDAC(void)
; {
	.dbline 169
; 	 old_DDR = SPI_DDR;//Storing old port directions
	in R2,0x4
	sts _old_DDR,R2
	.dbline 173
; 	 
; 	 //set up our port directions.  SS is setup as an output so that the
; 	 //SPI can not be turned into a slave
; 	 SPI_DDR |= (1<<MOSI) | (1<<SCLK) | (1<<SS);
	in R24,0x4
	ori R24,176
	out 0x4,R24
	.dbline 176
; 	 
; 	 //Set the enabkle pin as an output
; 	 DAC_EN_DIR |= (1<<DAC_EN);
	sbi 0x7,2
	.dbline 179
; 	 
; 	 //Ensure the DAC8501 is not enabled
; 	 DAC_EN_PORT |= (1<<DAC_EN);
	sbi 0x8,2
	.dbline 182
; 	 
; 	 //set up the SPI registers
; 	 SPCR = (1<<SPE) | (1<<MSTR) |(1<<CPOL) | (0<<CPHA);
	ldi R24,88
	out 0x2c,R24
	.dbline -2
L39:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReleaseDAC _ReleaseDAC fV
	.even
_ReleaseDAC::
	.dbline -1
	.dbline 191
;  	 
; }
; 
; /*
;  *Disable the SPI port and place the port directions
;  *back to how they where
;  */
; void ReleaseDAC(void)
; {
	.dbline 192
; 	 SPI_DDR = old_DDR;
	lds R2,_old_DDR
	out 0x4,R2
	.dbline 193
; 	 SPCR = 0x00;//Disable the SPI
	clr R2
	out 0x2c,R2
	.dbline -2
L40:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WriteDAC _WriteDAC fV
;           data -> R16,R17
	.even
_WriteDAC::
	.dbline -1
	.dbline 204
; }
; 
; /*
;  *Will write the data to the DAC8501
;  *
;  *            Vref X data
;  *   Vout =  ------------- 
;  *              65,536
;  */
; void WriteDAC(unsigned int data)
; {
	.dbline 206
; 	//select the DAC8501
; 	DAC_EN_PORT &= ~(1<<DAC_EN);
	cbi 0x8,2
	.dbline 212
; 	
; 	
; 	//if you need to modify PD (power-down modes)
; 	//modify this data
; 	//ie the data is X, X, X, X, X, X, PD1, PD0
; 	SPDR = 0x00;
	clr R2
	out 0x2e,R2
L42:
	.dbline 213
; 	while(!(SPSR & (1<<SPIF)));
L43:
	.dbline 213
	in R2,0x2d
	sbrs R2,7
	rjmp L42
X14:
	.dbline 215
; 	
; 	SPDR = data>>8;
	movw R2,R16
	mov R2,R3
	clr R3
	out 0x2e,R2
L45:
	.dbline 216
; 	while(!(SPSR & (1<<SPIF)));
L46:
	.dbline 216
	in R2,0x2d
	sbrs R2,7
	rjmp L45
X15:
	.dbline 219
; 	
; 	
; 	SPDR = (unsigned char)data;
	out 0x2e,R16
L48:
	.dbline 221
; 	
; 	while(!(SPSR & (1<<SPIF)));
L49:
	.dbline 221
	in R2,0x2d
	sbrs R2,7
	rjmp L48
X16:
	.dbline 224
; 	
; 	//deselect the DAC8501
; 	DAC_EN_PORT |= (1<<DAC_EN);
	sbi 0x8,2
	.dbline -2
L41:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 i
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\External_Converters.c
_old_DDR::
	.blkb 1
	.dbsym e old_DDR _old_DDR c
; 
; }
