	.module Wasp_SPI_Flash.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_SPI_Flash.c
	.dbfunc e FlashChipSelect _FlashChipSelect fV
;           mode -> R20
	.even
_FlashChipSelect::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 83
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_SPI_Flash.c	Version: 0.86
;    
;    Author:  SS	  					Date:  March 26, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    The AVR SPI lines are connected to two serial flash devices U2 
;    and U5. If the AVR needs to communicate with the Serial 
;    Flash devices the Blackfin must relinquish control of the SPI 
;    lines. 
;    
;    Serial flash devices compatible with the P1 are the AT45DB041
;    (512kx8), AT45DB081 (1Mx8), AT45DB161 (2Mx8), AT45DB321 (4Mx8)
;    or AT45DB642 (8Mx8).
;    
;    The Serial Flash chips are page oriented with 2 SRAM buffers of 264,
;    528 or 1024 bytes each.  The AVR programs the serial flash devices by 
;    loading files via the serial line (in IntelHex32 format) into the RAM 
;    buffers before transfer to the appropriate page.  Page erase/programming 
;    requires about 30msec per page. The routines in this file perform these 
;    functions.  The host terminal program must support XON/XOFF flow control.
;    
;    Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash Writer, XON/XOFF
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; // Set Serial Flash chip select state
; void FlashChipSelect(unsigned char mode)
; {
	.dbline 84
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	xcall _shortdelay
	.dbline 85
; 	 if(mode==LOW) PORTB &= 0xEF; 
	cpi R20,2
	brne L2
X0:
	.dbline 85
	in R24,0x5
	andi R24,239
	out 0x5,R24
	xjmp L3
L2:
	.dbline 86
; 	 else PORTB |= 0x10;  
	sbi 0x5,4
L3:
	.dbline 87
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	xcall _shortdelay
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e ConvertFlashAddress _ConvertFlashAddress fV
;     superpages -> R10,R11
;      bytestart -> R20,R21
;          pages -> R22,R23
;        address -> R12,R13
	.even
_ConvertFlashAddress::
	xcall push_xgsetF03C
	movw R12,R16
	.dbline -1
	.dbline 93
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+9 byte start bits
; void ConvertFlashAddress(unsigned int address)
; {
	.dbline 96
;  	int pages,bytestart,superpages;
; 	
; 	pages = address/flashpagesize0;
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R12
	xcall div16u
	movw R22,R16
	.dbline 97
; 	superpages = pages/7;
	ldi R18,7
	ldi R19,0
	xcall div16s
	movw R10,R16
	.dbline 98
; 	bytestart = address - pages*flashpagesize0;
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R22
	xcall empy16s
	movw R20,R12
	sub R20,R16
	sbc R21,R17
	.dbline 99
;     FlashAddress[0] = superpages;
	sts _FlashAddress,R10
	.dbline 100
; 	FlashAddress[1] = ((pages&0x00ff)<<1) + (bytestart>>8);
	movw R2,R20
	mov R2,R3
	clr R3
	sbrc R2,7
	com R3
	movw R24,R22
	andi R25,0
	lsl R24
	rol R25
	add R24,R2
	adc R25,R3
	sts _FlashAddress+1,R24
	.dbline 101
; 	FlashAddress[2] = bytestart & 0x00FF;
	movw R24,R20
	andi R25,0
	sts _FlashAddress+2,R24
	.dbline -2
L4:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r superpages 10 I
	.dbsym r bytestart 20 I
	.dbsym r pages 22 I
	.dbsym r address 12 i
	.dbend
	.dbfunc e SPI_SerialFlashStatus _SPI_SerialFlashStatus fc
;      instatus2 -> <dead>
;       instatus -> R10
	.even
_SPI_SerialFlashStatus::
	st -y,R10
	.dbline -1
	.dbline 106
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_SerialFlashStatus(void)
; {
	.dbline 110
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PB4 - Flash CS
; 	 FlashChipSelect(LOW);
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 113
; 
; 	 // Send read status command
;  	 SPI_MasterTransmit(SF_READ_STATUS);
	ldi R16,215
	xcall _SPI_MasterTransmit
	.dbline 115
; 
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	.dbline 116
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 119
; 	 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 121
; 	 
; 	 return instatus;
	mov R16,R10
	.dbline -2
L7:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym l instatus2 1 c
	.dbsym r instatus 10 c
	.dbend
	.dbfunc e SPI_StartReadFlashPage _SPI_StartReadFlashPage fV
;              i -> R20,R21
;        address -> R10,R11
	.even
_SPI_StartReadFlashPage::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 127
; }
; 
; //  SPI Flash continuous read command for AT45DB041B
; //  The AT45DB041B has 2048 264byte pages
; void SPI_StartReadFlashPage(unsigned int address)
; {
	.dbline 131
;  	 int i;
; 	 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(SF_READ_CONT);
	ldi R16,232
	xcall _SPI_MasterTransmit
	.dbline 134
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R10
	xcall _ConvertFlashAddress
	.dbline 135
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L9:
	.dbline 135
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L10:
	.dbline 135
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 135
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L9
X1:
	.dbline 138
; 	 
; 	 //  32 dummy bits
; 	 for(i=0; i<4; i++)  SPI_MasterTransmit(0x00);
	clr R20
	clr R21
L13:
	.dbline 138
	clr R16
	xcall _SPI_MasterTransmit
L14:
	.dbline 138
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 138
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brlt L13
X2:
	.dbline -2
L8:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r address 10 i
	.dbend
	.dbfunc e SPI_ReadFlashBuffer _SPI_ReadFlashBuffer fV
;              i -> R20,R21
;   buffernumber -> R20,R21
;        address -> R10,R11
	.even
_SPI_ReadFlashBuffer::
	xcall push_xgset300C
	movw R20,R18
	movw R10,R16
	.dbline -1
	.dbline 143
; }
; 
; //  SPI Flash Buffer Read command for AT45DB041B
; void SPI_ReadFlashBuffer(unsigned int address,unsigned int buffernumber)
; {
	.dbline 147
;  	 int i;
; 	 
; 	 // Send buffer read command
; 	 if(buffernumber==1) SPI_MasterTransmit(SF_READ_BUFFER1);
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne L18
X3:
	.dbline 147
	ldi R16,84
	xcall _SPI_MasterTransmit
	xjmp L19
L18:
	.dbline 148
; 	 else SPI_MasterTransmit(SF_READ_BUFFER2);
	ldi R16,86
	xcall _SPI_MasterTransmit
L19:
	.dbline 151
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R10
	xcall _ConvertFlashAddress
	.dbline 152
; 	 FlashAddress[0] = 0x00;
	clr R2
	sts _FlashAddress,R2
	.dbline 153
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L20:
	.dbline 153
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L21:
	.dbline 153
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 153
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L20
X4:
	.dbline 156
; 	 
; 	 //  8 dummy bits
; 	 SPI_MasterTransmit(0x00);
	clr R16
	xcall _SPI_MasterTransmit
	.dbline -2
L17:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r buffernumber 20 i
	.dbsym r address 10 i
	.dbend
	.dbfunc e DisplaySerialFlash _DisplaySerialFlash fV
;       numlines -> y+5
; bytesonlastline -> y+4
;        linecnt -> y+2
;     newaddress -> R12,R13
;      tempvalue -> R20
;       asciicnt -> y+1
;       crcvalue -> y+0
;           byte -> R22
;              i -> R10
;       readmode -> R20
;       numbytes -> R10,R11
;        address -> y+17
	.even
_DisplaySerialFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,7
	ldd R20,y+21
	.dbline -1
	.dbline 163
; }
; 
; 
; //  Display P1 Blackfin Flash memory
; //    Blackfin must be reset
; void DisplaySerialFlash(unsigned int address,unsigned int numbytes,char readmode)
; {
	.dbline 168
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 //  Set PC4 low - Flash CS
; 	 FlashChipSelect(LOW);  
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 170
; 
; 	 if(readmode==READCONTINUOUS) SPI_StartReadFlashPage(address);
	cpi R20,1
	brne L25
X5:
	.dbline 170
	ldd R16,y+17
	ldd R17,y+18
	xcall _SPI_StartReadFlashPage
	xjmp L26
L25:
	.dbline 171
; 	 else if(readmode==READBUFFER) SPI_ReadFlashBuffer(address,1);
	cpi R20,2
	brne L27
X6:
	.dbline 171
	ldi R18,1
	ldi R19,0
	ldd R16,y+17
	ldd R17,y+18
	xcall _SPI_ReadFlashBuffer
L27:
L26:
	.dbline 173
; //	 puts("Send Continuous Read command\n\r");
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+1,R0
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	.dbline 174
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 175
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+6,R17
	std y+5,R16
	.dbline 176
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R10
	sub R2,R16
	sbc R3,R17
	std y+4,R2
	xjmp L30
L29:
	.dbline 177
; 	 while(linecnt<numlines) {
	.dbline 178
; 	 	 crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 179
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 181
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 182
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 184
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 185
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 186
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 187
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 188
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 189
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 191
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L32
	ldi R17,>L32
	xcall _puts
	.dbline 193
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L36
L33:
	.dbline 193
	.dbline 194
; 	         byte = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R22,R16
	.dbline 195
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+1
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 196
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 197
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 198
; 	         }
L34:
	.dbline 193
	inc R10
L36:
	.dbline 193
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L33
X7:
	.dbline 199
; 		 linecnt++;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 200
; 		 asciicnt = 0;
	clr R0
	std y+1,R0
	.dbline 202
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 203
; 	     puts("  ");
	ldi R16,<L37
	ldi R17,>L37
	xcall _puts
	.dbline 204
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L41
L38:
	.dbline 204
	.dbline 205
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L42
X8:
	mov R24,R14
	cpi R24,128
	brsh L42
X9:
	.dbline 205
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L43
L42:
	.dbline 206
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L43:
	.dbline 207
; 			 }
L39:
	.dbline 204
	inc R10
L41:
	.dbline 204
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L38
X10:
	.dbline 208
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 209
; 		 }
L30:
	.dbline 177
	ldd R0,y+2
	ldd R1,y+3
	ldd R16,y+5
	ldd R17,y+6
	cp R0,R16
	cpc R1,R17
	brge X17
	xjmp L29
X17:
X11:
	.dbline 210
; 	 if(bytesonlastline) {
	ldd R0,y+4
	tst R0
	brne X18
	xjmp L44
X18:
X12:
	.dbline 210
	.dbline 211
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 212
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 214
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 215
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 217
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 218
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 219
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 220
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 221
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 222
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 224
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L32
	ldi R17,>L32
	xcall _puts
	.dbline 226
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L49
L46:
	.dbline 226
	.dbline 227
; 	         byte = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R20,R16
	mov R22,R20
	.dbline 228
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+1
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 229
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 230
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 231
; 	         }
L47:
	.dbline 226
	inc R10
L49:
	.dbline 226
	ldd R0,y+4
	cp R10,R0
	brlo L46
X13:
	.dbline 233
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 234
; 	     puts("  ");
	ldi R16,<L37
	ldi R17,>L37
	xcall _puts
	.dbline 235
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L53
L50:
	.dbline 235
	.dbline 236
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L54
X14:
	cpi R20,128
	brsh L54
X15:
	.dbline 236
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L55
L54:
	.dbline 237
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L55:
	.dbline 238
; 			 }
L51:
	.dbline 235
	inc R10
L53:
	.dbline 235
	ldd R0,y+4
	cp R10,R0
	brlo L50
X16:
	.dbline 239
; 		 putCRLF();
	xcall _putCRLF
	.dbline 242
; 		 
; 		 // Set PC4 high - deselect Flash chip
; 		 FlashChipSelect(HIGH);  
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 243
; 		 }
L44:
	.dbline -2
L24:
	.dbline 0 ; func end
	adiw R28,7
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 5 I
	.dbsym l bytesonlastline 4 c
	.dbsym l linecnt 2 I
	.dbsym r newaddress 12 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 1 c
	.dbsym l crcvalue 0 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r readmode 20 c
	.dbsym r numbytes 10 i
	.dbsym l address 17 i
	.dbend
	.dbfunc e ProgramBuffertoPageErase _ProgramBuffertoPageErase fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramBuffertoPageErase::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 249
; }
; 
; // Transfer buffer n to flash memory with built-in erase
; //  This operation takes about 20msec max
; void  ProgramBuffertoPageErase(unsigned char bufferid)
; {
	.dbline 253
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 256
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1) SPI_MasterTransmit(SF_BUF1_TO_FLASH_ERASE);
	cpi R20,1
	brne L57
X19:
	.dbline 256
	ldi R16,131
	xcall _SPI_MasterTransmit
	xjmp L58
L57:
	.dbline 257
; 	 else SPI_MasterTransmit(SF_BUF2_TO_FLASH_ERASE);
	ldi R16,134
	xcall _SPI_MasterTransmit
L58:
	.dbline 260
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 262
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L62
L59:
	.dbline 262
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L60:
	.dbline 262
	inc R20
L62:
	.dbline 262
	cpi R20,3
	brlo L59
X20:
	.dbline 265
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L56:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e EraseFlashPage _EraseFlashPage fV
;              i -> R20
	.even
_EraseFlashPage::
	st -y,R20
	.dbline -1
	.dbline 270
; }
; 
; // Maximum erase time is 20msec
; void  EraseFlashPage()
; {
	.dbline 274
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 277
; 	 
; 	 //  Buffer write
; 	 SPI_MasterTransmit(SF_PAGE_ERASE);
	ldi R16,129
	xcall _SPI_MasterTransmit
	.dbline 280
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 282
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L67
L64:
	.dbline 282
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L65:
	.dbline 282
	inc R20
L67:
	.dbline 282
	cpi R20,3
	brlo L64
X21:
	.dbline 285
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L63:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e ProgramFlashBuffer _ProgramFlashBuffer fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramFlashBuffer::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 290
; }
; 
; //  Load data into flash chip RAM buffer
; void ProgramFlashBuffer(unsigned char bufferid)
; {
	.dbline 294
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 297
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_WRITE_BUFFER1);
	cpi R20,1
	brne L69
X22:
	.dbline 297
	ldi R16,132
	xcall _SPI_MasterTransmit
	xjmp L70
L69:
	.dbline 298
; 	 else  SPI_MasterTransmit(SF_WRITE_BUFFER2);
	ldi R16,135
	xcall _SPI_MasterTransmit
L70:
	.dbline 301
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 303
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L74
L71:
	.dbline 303
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L72:
	.dbline 303
	inc R20
L74:
	.dbline 303
	cpi R20,3
	brlo L71
X23:
	.dbline 305
; 	 
; 	 for(i=0; i<bytesonline; i++)  SPI_MasterTransmit(intelbinary[i]);
	clr R20
	xjmp L78
L75:
	.dbline 305
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L76:
	.dbline 305
	inc R20
L78:
	.dbline 305
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R20
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L75
X24:
	.dbline 308
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L68:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e LoadFlashPage _LoadFlashPage fV
;              i -> R20
;       bufferid -> R20
	.even
_LoadFlashPage::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 312
; }
; 
; void LoadFlashPage(unsigned char bufferid)
; {
	.dbline 316
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 319
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_FLASH_TO_BUF1);
	cpi R20,1
	brne L80
X25:
	.dbline 319
	ldi R16,83
	xcall _SPI_MasterTransmit
	xjmp L81
L80:
	.dbline 320
; 	 else  SPI_MasterTransmit(SF_FLASH_TO_BUF2);
	ldi R16,85
	xcall _SPI_MasterTransmit
L81:
	.dbline 323
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 325
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L85
L82:
	.dbline 325
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L83:
	.dbline 325
	inc R20
L85:
	.dbline 325
	cpi R20,3
	brlo L82
X26:
	.dbline 328
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L79:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e WaitForFlashFree _WaitForFlashFree fV
	.even
_WaitForFlashFree::
	.dbline -1
	.dbline 333
;     
; }
; 
; void  WaitForFlashFree(void)
; { 	  
L87:
	.dbline 334
; 	  while(!(SPI_SerialFlashStatus()&0x80)) ;
L88:
	.dbline 334
	xcall _SPI_SerialFlashStatus
	sbrs R16,7
	rjmp L87
X27:
	.dbline -2
L86:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramSerialFlash _ProgramSerialFlash fV
;   shortbytecnt -> R10,R11
;   shortaddress -> y+4
;       newpage2 -> R12,R13
;        newpage -> R10,R11
;  globaladdress -> y+0
; firstbytesonline -> R14,R15
;     newbytecnt -> y+8
;              i -> R12,R13
	.even
_ProgramSerialFlash::
	xcall push_xgsetF0FC
	sbiw R28,10
	.dbline -1
	.dbline 355
; }
; 
; //  Main Serial Flash programming state controller
; //
; //  Serial flash chips are programmed one page at a time.  Each flash chip
; //  has two SRAM buffers.  Due to AVR limitations programming data is first
; //  loaded into the SRAM buffers then transferred to Flash.  SRAM buffers 
; //  range in size from 264 to 1024 bytes so the state machine must keep track
; //  of different buffer sizes.  IntelHex records range in size from 1 to 32
; //  bytes (AVR limitation) and can arrive at any start address.
; //
; //  As IntelHex records are received on the serial channel they are first
; //  loaded into Flash SRAM (AVR doesn't have enough SRAM available) and then
; //  written to a Flash page if a termination record is received or the SRAM 
; //  buffer becomes full.  To prevent Flash overwrite a Flash page is first 
; //  loaded into SRAM and new data overwritten in SRAM.  
; //
; //  To reduce variable use bytesonline, inteladdress and intelsuperaddress
; //  are global variables.
; void ProgramSerialFlash(void)
; {
	.dbline 359
;  	 long globaladdress,shortaddress;
; 	 int newpage,newpage2,shortbytecnt,newbytecnt,i,firstbytesonline;
; 	 
; 	 globaladdress = intelsuperaddress*65536 + inteladdress;
	lds R2,_intelsuperaddress
	lds R3,_intelsuperaddress+1
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	movw R2,R16
	movw R4,R18
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	clr R8
	clr R9
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 360
; 	 newpage = globaladdress/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R10,R16
	.dbline 361
; 	 oldinteladdress = inteladdress;
	lds R2,_inteladdress
	lds R3,_inteladdress+1
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	.dbline 365
; //	 puts(" ga="); PrintWordHex(inteladdress); putcharr(' ');
; 	 
;      // Always load flash page for first record
;  	 if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L91
X28:
	.dbline 365
	.dbline 366
; 	     totalbytecnt = 0;
	clr R2
	clr R3
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 367
; 		 LoadFlashPage(1);
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 368
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	xcall _WaitForFlashFree
	.dbline 369
; 	     flashprogrammingactive = YES;
	ldi R24,1
	sts _flashprogrammingactive,R24
	.dbline 370
; 		 flashpageloaded = YES;
	sts _flashpageloaded,R24
	.dbline 371
; 		 oldpage = newpage;
	sts _oldpage+1,R11
	sts _oldpage,R10
	.dbline 372
; 		 }
	xjmp L92
L91:
	.dbline 376
; 
;  	 // See if flash page was loaded - preserves old data not in the new
; 	 // record from being overwritten
;  	 else if(flashpageloaded==NO)  {
	lds R2,_flashpageloaded
	tst R2
	brne L93
X29:
	.dbline 376
	.dbline 377
; 	     LoadFlashPage(1);
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 378
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	xcall _WaitForFlashFree
	.dbline 379
; 		 flashpageloaded = YES;
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 380
; 		 }
L93:
L92:
	.dbline 385
; 		 
; 	 // See if number of bytes in record causes a page boundary traverse
; 	 //  tbd - what if buffer fills exactly?
; //	 newbytecnt = bytesonline;
; 	 newpage2 = (globaladdress+bytesonline)/flashpagesize0;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R12,R16
	.dbline 386
; 	 shortaddress = newpage*flashpagesize0;	 
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R10
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	.dbline 392
; //     if((globaladdress+bytesonline-1)==(shortaddress+flashpagesize0-1)) {
; //	    puts(" yureka ");
; //		printf(" ad=%x ",inteladdress);
; //		}
; 
; 	 if(newpage!=newpage2) {
	cp R10,R12
	cpc R11,R13
	breq L95
X30:
	.dbline 392
	.dbline 393
; 	     flashpageboundarytraversed = YES;
	ldi R24,1
	sts _flashpageboundarytraversed,R24
	.dbline 394
; 	     shortbytecnt = flashpagesize0 - (globaladdress - shortaddress);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	movw R10,R2
	.dbline 395
; 	     newbytecnt = bytesonline - shortbytecnt;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	sub R2,R10
	sbc R3,R11
	std y+9,R3
	std y+8,R2
	.dbline 397
; //		 printf(" ad=%x ",inteladdress);
; 		 firstbytesonline = bytesonline;
	lds R14,_bytesonline
	lds R15,_bytesonline+1
	.dbline 398
; 		 bytesonline = shortbytecnt;
	sts _bytesonline+1,R11
	sts _bytesonline,R10
	.dbline 400
; //		 printf(" sc=%d %d ",shortbytecnt,newbytecnt);
; 		 }
L95:
	.dbline 402
; 	 
; 	 totalbytecnt += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	lds R4,_totalbytecnt
	lds R5,_totalbytecnt+1
	add R4,R2
	adc R5,R3
	sts _totalbytecnt+1,R5
	sts _totalbytecnt,R4
	.dbline 403
; 	 ProgramFlashBuffer(1); 
	ldi R16,1
	xcall _ProgramFlashBuffer
	.dbline 405
; //	 printf(" lb=%d",totalbytecnt); 
; 	 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 408
; 	 
; 	 //  If Buffer full or boundary traversed transfer buffer to flash
; 	 if((newbytecnt==0)||(flashpageboundarytraversed==YES))  {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	brne X31
	tst R1
	breq L99
X31:
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	brne L97
X32:
L99:
	.dbline 408
	.dbline 409
; 	     ProgramBuffertoPageErase(1);
	ldi R16,1
	xcall _ProgramBuffertoPageErase
	.dbline 410
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	xcall _WaitForFlashFree
	.dbline 411
; 		 flashpageloaded = NO;
	clr R2
	sts _flashpageloaded,R2
	.dbline 412
; 		 flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 414
; //		 printf(" fp=%d",newpage); 
; 		 }
L97:
	.dbline 417
; 	 
; 	 //  If record caused a page boundary traversal load next page
; 	 if(flashpageboundarytraversed==YES) {
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	breq X35
	xjmp L100
X35:
X33:
	.dbline 417
	.dbline 419
; 	     //newpage++;       // goto next page
; 		 oldpage = newpage2;
	sts _oldpage+1,R13
	sts _oldpage,R12
	.dbline 421
; //		 printf(" tp=%d ",newpage);
; 		 inteladdress = newpage2*flashpagesize0;  // start address at page bdry
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R12
	xcall empy16s
	sts _inteladdress+1,R17
	sts _inteladdress,R16
	.dbline 422
; 	 	 oldinteladdress = inteladdress;
	movw R2,R16
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	.dbline 423
; 		 LoadFlashPage(1);   // Load the new page - this may be last record
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 425
; 		                     // So don't overwrite remaining content in page
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	xcall _WaitForFlashFree
	.dbline 426
; 		 flashpageloaded = YES;  // Page loaded so don't do it again next recrd
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 427
; 		 for(i=0; i<newbytecnt; i++)  // Shift record data to start
	clr R12
	clr R13
	xjmp L105
L102:
	.dbline 428
; 		      intelbinary[i] = intelbinary[firstbytesonline-newbytecnt+i];
	movw R30,R14
	ldd R0,y+8
	ldd R1,y+9
	sub R30,R0
	sbc R31,R1
	add R30,R12
	adc R31,R13
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R30,R12
	add R30,R24
	adc R31,R25
	std z+0,R2
L103:
	.dbline 427
	movw R24,R12
	adiw R24,1
	movw R12,R24
L105:
	.dbline 427
	ldd R0,y+8
	ldd R1,y+9
	cp R12,R0
	cpc R13,R1
	brlt L102
X34:
	.dbline 429
; 		 bytesonline = newbytecnt;  // Only write new data in record
	sts _bytesonline+1,R1
	sts _bytesonline,R0
	.dbline 431
; //		 printf(" newcnt=",newbytecnt);
; 		 ProgramFlashBuffer(1);  // write remaining record to RAM buffer
	ldi R16,1
	xcall _ProgramFlashBuffer
	.dbline 432
; 		 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 433
; 		 totalbytecnt += newbytecnt;
	lds R2,_totalbytecnt
	lds R3,_totalbytecnt+1
	ldd R0,y+8
	ldd R1,y+9
	add R2,R0
	adc R3,R1
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 434
; 		 flashpageboundarytraversed=NO;
	clr R2
	sts _flashpageboundarytraversed,R2
	.dbline 435
; 	     }
L100:
	.dbline -2
L90:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
	.dbsym r shortbytecnt 10 I
	.dbsym l shortaddress 4 L
	.dbsym r newpage2 12 I
	.dbsym r newpage 10 I
	.dbsym l globaladdress 0 L
	.dbsym r firstbytesonline 14 I
	.dbsym l newbytecnt 8 I
	.dbsym r i 12 I
	.dbend
	.dbfunc e FlashPageSize _FlashPageSize fI
;       sizecode -> R16
	.even
_FlashPageSize::
	.dbline -1
	.dbline 440
; }
; 
; // Return Serial Flash page size
; int FlashPageSize(unsigned char sizecode)
; {
	.dbline 441
;  	 if((sizecode==AT45DB041ID)||(sizecode==AT45DB081ID))  return 264;
	cpi R16,28
	breq L109
X36:
	cpi R16,36
	brne L107
X37:
L109:
	.dbline 441
	ldi R16,264
	ldi R17,1
	xjmp L106
L107:
	.dbline 442
; 	 else if((sizecode==AT45DB161ID)||(sizecode==AT45DB321ID)) return 528;
	cpi R16,44
	breq L112
X38:
	cpi R16,52
	brne L110
X39:
L112:
	.dbline 442
	ldi R16,528
	ldi R17,2
	xjmp L106
L110:
	.dbline 443
; 	 else if(sizecode==AT45DB642ID) return 1024;
	cpi R16,36
	brne L113
X40:
	.dbline 443
	ldi R16,1024
	ldi R17,4
	xjmp L106
L113:
	.dbline 444
; 	 else return 0;
	clr R16
	clr R17
	.dbline -2
L106:
	.dbline 0 ; func end
	ret
	.dbsym r sizecode 16 c
	.dbend
	.dbfunc e CheckFlashTypes _CheckFlashTypes fV
	.even
_CheckFlashTypes::
	.dbline -1
	.dbline 451
; }
; 
; //  Search for serial flash chips U2, U5
; //  U2 is always present while U5 is optional
; //  This routine initializes SPI and resets Blackfin
; void  CheckFlashTypes()
; {
	.dbline 452
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 453
; 	Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 454
; 	flashtype0 = SPI_SerialFlashStatus()&FLASHIDMASK;
	xcall _SPI_SerialFlashStatus
	mov R24,R16
	andi R24,60
	sts _flashtype0,R24
	.dbline 455
; 	flashpagesize0 = FlashPageSize(flashtype0);		
	mov R16,R24
	xcall _FlashPageSize
	sts _flashpagesize0+1,R17
	sts _flashpagesize0,R16
	.dbline 456
; 	Release_SPI();
	xcall _Release_SPI
	.dbline -2
L115:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_SPI_Flash.c
L37:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_SPI_Flash.c
L32:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_SPI_Flash.c
; }
; 
; 	
