	.module Wasp_Uart.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Uart.c
	.dbfunc e putchar _putchar$device_specific$ fI
;        tmphead -> R20
;         indata -> R16
	.even
_putchar$device_specific$::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 68
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_Uart.c	Version: 0.86
;    
;    Author:  SS	  			    Date:  March 26, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement basic Usart put/get functions.
;    
;    Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; int putchar(unsigned char indata)
; {
	.dbline 72
; 	unsigned char tmphead;
; 	
; 	// Calculate buffer index
; 	tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK; 
	lds R20,_UART_TxHead
	subi R20,255    ; addi 1
	andi R20,63
L2:
	.dbline 75
; 		
; 	// Wait for free space in buffer
; 	while(tmphead == UART_TxTail) ;
L3:
	.dbline 75
	lds R2,_UART_TxTail
	cp R20,R2
	breq L2
X0:
	.dbline 77
; 	
; 	UART_TxBuf[tmphead] = indata; // store data in buffer
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 78
; 	UART_TxHead = tmphead;      // store new index
	sts _UART_TxHead,R20
	.dbline 81
; 
; 	// Expand LF to CRLF is textmode globel set
; 	if((indata==LF)&&(_textmode==1)) {
	cpi R16,10
	brne L5
X1:
	lds R24,__textmode
	lds R25,__textmode+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L5
X2:
	.dbline 81
	.dbline 83
; 		// Calculate buffer index
; 		tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK; 
	subi R20,255    ; addi 1
	andi R20,63
L7:
	.dbline 86
; 		
; 		// Wait for free space in buffer
; 		while(tmphead == UART_TxTail) ;
L8:
	.dbline 86
	lds R2,_UART_TxTail
	cp R20,R2
	breq L7
X3:
	.dbline 88
; 	
; 		UART_TxBuf[tmphead] = CR; // store data in buffer
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,13
	std z+0,R24
	.dbline 89
; 		UART_TxHead = tmphead;      // store new index
	sts _UART_TxHead,R20
	.dbline 90
; 		}
L5:
	.dbline 92
; 
; 	UCSR0B |= (1<<UDRIE0);        // Fire TX UDRIE interrupt
	lds R24,193
	ori R24,32
	sts 193,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r tmphead 20 c
	.dbsym r indata 16 c
	.dbend
	.dbfunc e putcharr _putcharr fV
;         indata -> R10
	.even
_putcharr::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 96
; }
; 
; void putcharr(unsigned char indata)
; {
	.dbline 97
;  	putchar(indata);
	mov R16,R10
	xcall _putchar$device_specific$
	.dbline -2
L10:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r indata 10 c
	.dbend
	.dbfunc e getcharnw _getcharnw fc
;          rxtmp -> <dead>
;        tmptail -> R16
	.even
_getcharnw::
	.dbline -1
	.dbline 102
; }
; 
; // Read and write functions
; unsigned char getcharnw(void)
; {
	.dbline 105
; 	unsigned char tmptail,rxtmp;
; 
; 	if(UART_RxHead==UART_RxTail) return 0; // nothing to get
	lds R2,_UART_RxTail
	lds R3,_UART_RxHead
	cp R3,R2
	brne L12
X4:
	.dbline 105
	clr R16
	xjmp L11
L12:
	.dbline 107
; 		
; 	tmptail = (UART_RxTail+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R16,_UART_RxTail
	subi R16,255    ; addi 1
	andi R16,63
	.dbline 108
; 	UART_RxTail = tmptail;     // store new index
	sts _UART_RxTail,R16
	.dbline 111
; 	
; //	_CLI();
; 	rxcnt--;
	lds R24,_rxcnt
	subi R24,1
	sts _rxcnt,R24
	.dbline 112
; 	if(rxcnt<0) rxcnt = 0;
	cpi R24,0
	brsh L14
X5:
	.dbline 112
	clr R2
	sts _rxcnt,R2
L14:
	.dbline 128
; //	rxtmp = rxcnt;
; //	_SEI();    // Enable interrupts => enable UART interrupts
; 
; //	if(rxtmp < 0) putcharr('<');
; //	if(rxtmp > 0x3f) putcharr('>');
; 
; 	// Allow tx at remote serial device again - buffer has more space
; //	if((rxtmp<(UART_RX_BUFFER_SIZE-40))&&(xoffsent==YES)&&(enablexonoff==YES)) {
; //		if(xonsent==NO) {
; //			putcharr(XON);
; // 			putcharr('$');
; //			xonsent = YES;
; //			}
; //		}
; 
; 	return UART_RxBuf[tmptail];   // return data
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbsym l rxtmp 1 c
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e getcharr _getcharr fc
;         inchar -> R10
	.even
_getcharr::
	st -y,R10
	.dbline -1
	.dbline 133
; }
; 
; // Getchar waits until a valid character is received
; unsigned char getcharr(void)
; {
L17:
	.dbline 136
;     unsigned char inchar;
; 	
;  	while(!(inchar=getcharnw())) ;
L18:
	.dbline 136
	xcall _getcharnw
	mov R10,R16
	tst R10
	breq L17
X6:
	.dbline 137
; 	if(echoinchars==YES) putcharr(inchar);
	lds R24,_echoinchars
	cpi R24,1
	brne L20
X7:
	.dbline 137
	xcall _putcharr
L20:
	.dbline 138
; 	return inchar;
	mov R16,R10
	.dbline -2
L16:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e InittUART _InittUART fV
;       baudrate -> R16
	.even
_InittUART::
	.dbline -1
	.dbline 143
; }
; 
; /* Initialize UART */
; void InittUART(unsigned char baudrate)
; {
	.dbline 145
;  	/* set the baud rate */
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 146
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline 147
; 	UCSR0B = BIT(RXEN0) | BIT(TXEN0); /* enable UART receiver and transmitter */
	ldi R24,24
	sts 193,R24
	.dbline 151
;     //  8 data bits, 2 stop bits
; //	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
;     //  8 data bits, 1 stop bit
; 	UCSR0C = (1<<UMSEL00)|(3<<UCSZ00);
	ldi R24,70
	sts 194,R24
	.dbline -2
L22:
	.dbline 0 ; func end
	ret
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e ReceiveByte _ReceiveByte fc
	.even
_ReceiveByte::
	.dbline -1
	.dbline 156
; }
; 
; // Polled receive function - non-wait
; unsigned char ReceiveByte(void)
; {
	.dbline 157
; 	if((UCSR0A & (1<<RXC0))) return UDR0;
	lds R2,192
	sbrs R2,7
	rjmp L24
X8:
	.dbline 157
	lds R16,198
	xjmp L23
L24:
	.dbline 158
; 	else return 0x00;
	clr R16
	.dbline -2
L23:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TransmitByte _TransmitByte fV
;           data -> R16
	.even
_TransmitByte::
	.dbline -1
	.dbline 163
; }
; 
; // Polled transmit function
; void TransmitByte(unsigned char data)
; {
L27:
	.dbline 165
; 	while ( !(UCSR0A & (1<<UDRE0)) )
; 		; /* wait for empty transmit buffer */
L28:
	.dbline 164
	lds R2,192
	sbrs R2,5
	rjmp L27
X9:
	.dbline 166
; 	UDR0 = data; /* start transmission */
	sts 198,R16
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 c
	.dbend
	.dbfunc e puttchar _puttchar fV
;           data -> R10
	.even
_puttchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 171
; }
; 
; //  Buffered write to UART - wait until transmitted
; void puttchar(unsigned char data)
; {
	.dbline 172
;  	 TransmitByte(data);
	mov R16,R10
	xcall _TransmitByte
	.dbline -2
L30:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbend
	.dbfunc e gettchar _gettchar fc
;         inchar -> R10
	.even
_gettchar::
	st -y,R10
	.dbline -1
	.dbline 178
; }
; 
; //  Buffered character read from UART - don't return if 
; //  character is Null
; unsigned char gettchar(void)
; {
L32:
	.dbline 181
;      unsigned char inchar;
; 	 
;  	 while(!(inchar=ReceiveByte())) ;
L33:
	.dbline 181
	xcall _ReceiveByte
	mov R10,R16
	tst R10
	breq L32
X10:
	.dbline 182
;  	 return inchar;
	.dbline -2
L31:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e putss _putss fV
;              i -> R20,R21
;        outstrg -> R10,R11
	.even
_putss::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 221
; }
; 
; /*
; //  Convert binary value to ASCII int
; void printint(int intvalue,char charcnt,char leadchartype)
; {
;  	 char outvalue[6],nolead;
;  	 int  i,tenthousands, thousands, hundreds, tens;
; 	 
; 	 if(intvalue >= 0) putcharr(' ');
; 	 else {
; 	 	  putcharr('-');
; 	 	  intvalue *= -1;
; 		  }
; 	 tenthousands = intvalue/10000;
; 	 intvalue -= (tenthousands*10000);
; 	 thousands = intvalue/1000;
; 	 intvalue -= (thousands*1000);
; 	 hundreds = intvalue/100;
; 	 intvalue -= (hundreds*100);
; 	 tens = intvalue/10;
; 	 nolead = 0x00;
; 	 // TODO - suppress only leading zero's
; 	 if(tenthousands)  {outvalue[0] = '0' + tenthousands; nolead=0x01;}
; 	 else outvalue[0] = leadchartype;
; 	 if(thousands|nolead) {outvalue[1] = '0' + thousands;nolead=0x01;}
; 	 else outvalue[1] = leadchartype;
; 	 if(hundreds|nolead) {outvalue[2] = '0' + hundreds;nolead=0x01;}
; 	 else outvalue[2] = leadchartype;
; 	 if(tens|nolead) outvalue[3] = '0' + tens;
; 	 else outvalue[3] = leadchartype;
; 	 outvalue[4] = '0' + intvalue%10; 
; 	 outvalue[5] = 0x00;
; 	 for(i=0; i<charcnt; i++) putcharr(outvalue[(5-charcnt)+i]);
; }
; */
; 
; void putss(char *outstrg)
; {
	.dbline 224
;  	 int i;
; 	 
; 	 for(i=0; i<strlen(outstrg); i++)  putcharr(outstrg[i]);
	clr R20
	clr R21
	xjmp L39
L36:
	.dbline 224
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _putcharr
L37:
	.dbline 224
	subi R20,255  ; offset = 1
	sbci R21,255
L39:
	.dbline 224
	movw R16,R10
	xcall _strlen
	cp R20,R16
	cpc R21,R17
	brlo L36
X11:
	.dbline -2
L35:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r outstrg 10 pc
	.dbend
	.dbfunc e putCRLF _putCRLF fV
	.even
_putCRLF::
	.dbline -1
	.dbline 228
; }
; 
; void putCRLF()
; {
	.dbline 229
;  	 puts("\n\r");
	ldi R16,<L41
	ldi R17,>L41
	xcall _puts
	.dbline -2
L40:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e putfs _putfs fV
;              i -> R20,R21
;         inchar -> R10
;        signon1 -> R12,R13
	.even
_putfs::
	xcall push_xgset303C
	movw R12,R16
	.dbline -1
	.dbline 235
; }
; 
; 
; //  Load string constant from Flash (conserves RAM)
; void putfs(const char *signon1)
; { 	
	.dbline 239
; 	char inchar;
;     int i;
; 	
; 	i = 0;
	clr R20
	clr R21
	xjmp L44
L43:
	.dbline 240
; 	while((inchar=*(signon1+i++))!=0x00)  putcharr(inchar);
	mov R16,R10
	xcall _putcharr
L44:
	.dbline 240
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R2
	add R30,R12
	adc R31,R13
	lpm R2,Z
	mov R10,R2
	tst R10
	brne L43
X12:
	.dbline -2
L42:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r inchar 10 c
	.dbsym r signon1 12 pkc
	.dbend
	.dbfunc e bytetohex _bytetohex fV
;         inchar -> <dead>
;         inbyte -> R20
;           byte -> R16
	.even
_bytetohex::
	st -y,R20
	.dbline -1
	.dbline 245
; }
; 
; //  Convert byte to ASCII hex
; void bytetohex(unsigned char byte)
; {
	.dbline 248
;     unsigned char inbyte,inchar;
; 	
; 	inbyte = byte & 0x0f;
	mov R20,R16
	andi R20,15
	.dbline 249
; 	if(inbyte > 9) hexbyte[1] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L47
X13:
	.dbline 249
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte+1,R24
	xjmp L48
L47:
	.dbline 250
; 	else hexbyte[1] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
L48:
	.dbline 251
; 	inbyte = byte & 0xf0;
	mov R20,R16
	andi R20,240
	.dbline 252
; 	inbyte >>= 4;
	mov R24,R20
	swap R24
	andi R24,#0x0F
	mov R20,R24
	.dbline 253
; 	if(inbyte >9) hexbyte[0] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L51
X14:
	.dbline 253
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte,R24
	xjmp L52
L51:
	.dbline 254
; 	else hexbyte[0] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte,R24
L52:
	.dbline 255
;     hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l inchar 1 c
	.dbsym r inbyte 20 c
	.dbsym r byte 16 c
	.dbend
	.dbfunc e addresstohex _addresstohex fV
;       highbyte -> R10
;        lowbyte -> R10
;        address -> R20,R21
	.even
_addresstohex::
	xcall push_xgset300C
	movw R20,R16
	.dbline -1
	.dbline 260
; }
; 
; // Convert word to ASCII Hex
; void addresstohex(unsigned int address)
; {
	.dbline 263
;  	 unsigned char lowbyte,highbyte;
; 	 
; 	 lowbyte = address & 0x00FF;
	movw R24,R20
	andi R25,0
	.dbline 264
; 	 bytetohex(lowbyte);
	mov R16,R24
	xcall _bytetohex
	.dbline 265
; 	 hexaddress[2] = hexbyte[0];
	lds R2,_hexbyte
	sts _hexaddress+2,R2
	.dbline 266
; 	 hexaddress[3] = hexbyte[1];
	lds R2,_hexbyte+1
	sts _hexaddress+3,R2
	.dbline 267
; 	 highbyte = address/256;
	movw R10,R20
	mov R10,R11
	clr R11
	.dbline 268
; 	 bytetohex(highbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 269
; 	 hexaddress[0] = hexbyte[0];
	lds R2,_hexbyte
	sts _hexaddress,R2
	.dbline 270
; 	 hexaddress[1] = hexbyte[1];
	lds R2,_hexbyte+1
	sts _hexaddress+1,R2
	.dbline 271
; 	 hexaddress[4] = 0x00;
	clr R2
	sts _hexaddress+4,R2
	.dbline -2
L54:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r highbyte 10 c
	.dbsym r lowbyte 10 c
	.dbsym r address 20 i
	.dbend
	.dbfunc e converttohex _converttohex fc
;      lownibble -> R20
;     highnibble -> R22
;         instrg -> R16,R17
	.even
_converttohex::
	xcall push_xgsetF03C
	.dbline -1
	.dbline 276
; }
; 
; // Convert ASCII hex to binary
; unsigned char converttohex(char *instrg)
; {
	.dbline 279
;  	 unsigned char lownibble, highnibble;
; 	 
; 	 if((instrg[0] >= 'A')&(instrg[0]<='F')) highnibble = instrg[0] - 'A' + 10;
	movw R30,R16
	ldd R24,z+0
	cpi R24,65
	brlo L64
X15:
	ldi R22,1
	ldi R23,0
	xjmp L65
L64:
	clr R22
	clr R23
L65:
	ldi R24,70
	movw R30,R16
	ldd R2,z+0
	cp R24,R2
	brlo L66
X16:
	ldi R20,1
	ldi R21,0
	xjmp L67
L66:
	clr R20
	clr R21
L67:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X17
	tst R3
	breq L62
X17:
	.dbline 279
	movw R30,R16
	ldd R22,z+0
	subi R22,65
	subi R22,246    ; addi 10
	xjmp L63
L62:
	.dbline 280
; 	 else if((instrg[0] >= 'a')&(instrg[0]<='f')) highnibble = instrg[0] - 'a' + 10;
	movw R30,R16
	ldd R24,z+0
	cpi R24,97
	brlo L70
X18:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L71
L70:
	clr R10
	clr R11
L71:
	ldi R24,102
	movw R30,R16
	ldd R2,z+0
	cp R24,R2
	brlo L72
X19:
	ldi R20,1
	ldi R21,0
	xjmp L73
L72:
	clr R20
	clr R21
L73:
	movw R2,R10
	and R2,R20
	and R3,R21
	tst R2
	brne X20
	tst R3
	breq L68
X20:
	.dbline 280
	movw R30,R16
	ldd R22,z+0
	subi R22,97
	subi R22,246    ; addi 10
	xjmp L69
L68:
	.dbline 281
; 	 else highnibble = instrg[0] - '0';
	movw R30,R16
	ldd R22,z+0
	subi R22,48
L69:
L63:
	.dbline 283
; 	 
; 	 if((instrg[1] >= 'A')&(instrg[1]<='F')) lownibble = instrg[1] - 'A' + 10;
	movw R30,R16
	ldd R24,z+1
	cpi R24,65
	brlo L76
X21:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L77
L76:
	clr R10
	clr R11
L77:
	ldi R24,70
	movw R30,R16
	ldd R2,z+1
	cp R24,R2
	brlo L78
X22:
	ldi R20,1
	ldi R21,0
	xjmp L79
L78:
	clr R20
	clr R21
L79:
	movw R2,R10
	and R2,R20
	and R3,R21
	tst R2
	brne X23
	tst R3
	breq L74
X23:
	.dbline 283
	movw R30,R16
	ldd R20,z+1
	subi R20,65
	subi R20,246    ; addi 10
	xjmp L75
L74:
	.dbline 284
; 	 else if((instrg[1] >= 'a')&(instrg[1]<='f')) lownibble = instrg[1] - 'a' + 10;
	movw R30,R16
	ldd R24,z+1
	cpi R24,97
	brlo L82
X24:
	ldi R24,1
	ldi R25,0
	movw R12,R24
	xjmp L83
L82:
	clr R12
	clr R13
L83:
	ldi R24,102
	movw R30,R16
	ldd R2,z+1
	cp R24,R2
	brlo L84
X25:
	ldi R24,1
	ldi R25,0
	movw R10,R24
	xjmp L85
L84:
	clr R10
	clr R11
L85:
	movw R2,R12
	and R2,R10
	and R3,R11
	tst R2
	brne X26
	tst R3
	breq L80
X26:
	.dbline 284
	movw R30,R16
	ldd R20,z+1
	subi R20,97
	subi R20,246    ; addi 10
	xjmp L81
L80:
	.dbline 285
; 	 else lownibble = instrg[1] - '0';
	movw R30,R16
	ldd R20,z+1
	subi R20,48
L81:
L75:
	.dbline 287
; 	 
; 	 highnibble = highnibble<<4;
	mov R24,R22
	andi R24,#0x0F
	swap R24
	mov R22,R24
	.dbline 288
; 	 return highnibble + lownibble;
	mov R16,R24
	add R16,R20
	.dbline -2
L61:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r lownibble 20 c
	.dbsym r highnibble 22 c
	.dbsym r instrg 16 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Uart.c
L41:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Uart.c
; }
; 
