	.module Wasp_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_Utilities.c	Version: 0.86
;    
;    Author:  SS	  					  Date:  March 26, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the Wasp Monitor.
;    
;    Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC ROBOTICS, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e shortdelay _shortdelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_shortdelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void shortdelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e GREEN_LED _GREEN_LED fV
;           mode -> R16
	.even
_GREEN_LED::
	.dbline -1
	.dbline 107
; }
; 
; void GREEN_LED(unsigned char mode)
; {
	.dbline 108
;  	if(mode==ON) PORTD &= ~BIT(5);	// low output to turn LED on
	tst R16
	brne L24
X5:
	.dbline 108
	cbi 0xb,5
	xjmp L25
L24:
	.dbline 109
; 	else PORTD |= BIT(5);	// low output to turn LED off
	sbi 0xb,5
L25:
	.dbline -2
L23:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RED_LED _RED_LED fV
;           mode -> R16
	.even
_RED_LED::
	.dbline -1
	.dbline 113
; }
; 
; void RED_LED(unsigned char mode)
; {
	.dbline 114
;  	 if(mode==ON) PORTD &= ~BIT(4);	
	tst R16
	brne L27
X6:
	.dbline 114
	cbi 0xb,4
	xjmp L28
L27:
	.dbline 115
; 	 else PORTD |= BIT(4);	
	sbi 0xb,4
L28:
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 122
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 124
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 125
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 126
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 127
; 	CLI();													// disable interrupts
	cli
	.dbline 128
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 129
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 130
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 131
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L29:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 137
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L31:
	.dbline 138
;  	 while(!RTEEPROMReady())  ;
L32:
	.dbline 138
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L31
X7:
	.dbline 139
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L34:
	.dbline 140
;  	 while(!RTEEPROMReady())  ;
L35:
	.dbline 140
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L34
X8:
	.dbline -2
L30:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e WriteEEPROM _WriteEEPROM fV
;              i -> R20,R21
;           strg -> R10,R11
;       location -> R12,R13
	.even
_WriteEEPROM::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	.dbline -1
	.dbline 145
; }
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg)
; {
	.dbline 148
;  	 int i;
; 	 
; 	 i = 0;
	clr R20
	clr R21
	xjmp L39
L38:
	.dbline 149
; 	 while(strg[i] != 0x00)  {
	.dbline 150
; 	     EEPROMWrite(location+i,strg[i]);
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R18,z+0
	movw R16,R12
	add R16,R20
	adc R17,R21
	xcall _EEPROMWrite
	.dbline 151
; 		 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 152
; 		 }
L39:
	.dbline 149
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L38
X9:
	.dbline -2
L37:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r strg 10 pc
	.dbsym r location 12 I
	.dbend
	.dbfunc e BlinkGreen _BlinkGreen fV
;         period -> R10,R11
	.even
_BlinkGreen::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 156
; }
; 
; void BlinkGreen(int period)
; {
	.dbline 157
;  	 GREEN_LED(ON);
	clr R16
	xcall _GREEN_LED
	.dbline 158
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 159
; 	 GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 160
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L41:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e BlinkRed _BlinkRed fV
;         period -> R10,R11
	.even
_BlinkRed::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 164
; }
; 
; void BlinkRed(int period)
; {
	.dbline 165
;  	 RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 166
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 167
; 	 RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 168
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L42:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e PrintHex _PrintHex fV
;         inbyte -> R10
	.even
_PrintHex::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 172
; }
; 
; void PrintHex(unsigned char inbyte)
; {
	.dbline 173
;  	 bytetohex(inbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 174
; 	 puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline -2
L43:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inbyte 10 c
	.dbend
	.dbfunc e PrintWordHex _PrintWordHex fV
;         inword -> R10,R11
	.even
_PrintWordHex::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 178
; }
; 
; void PrintWordHex(unsigned int inword)
; {
	.dbline 179
;  	 addresstohex(inword);
	movw R16,R10
	xcall _addresstohex
	.dbline 180
; 	 puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline -2
L44:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r inword 10 i
	.dbend
	.dbfunc e EEPROMSetup _EEPROMSetup fV
	.even
_EEPROMSetup::
	.dbline -1
	.dbline 185
; }
; 
; //  TBD
; void EEPROMSetup(void)
; {
	.dbline -2
L45:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReadAVRFlash _ReadAVRFlash fc
;          rbyte -> R10
;      flashbyte -> R10
;        address -> <dead>
	.even
_ReadAVRFlash::
	st -y,r17
	st -y,r16
	st -y,R10
	.dbline -1
	.dbline 191
;  	
; }
; 
; //  Access contents of AVR flash at specified address
; unsigned char ReadAVRFlash(int address)
; {
	.dbline 194
;  	unsigned char flashbyte,rbyte;
; 	
; 	flashbyte = 0;
	clr R10
	.dbline 195
;  	asm("mov r30,r16 \n"
	mov r30,r16 
	mov r31,r17 
	lpm r0,Z 
	mov R10,r0 
	
	.dbline 199
;        "mov r31,r17 \n"
; 	   "lpm r0,Z \n"
; 	   "mov %flashbyte,r0 \n"); 
; 	rbyte = flashbyte;  
	.dbline 200
; 	return(rbyte);                              
	mov R16,R10
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,2
	ret
	.dbsym r rbyte 10 c
	.dbsym r flashbyte 10 c
	.dbsym l address 1 I
	.dbend
	.dbfunc e signon _signon fV
	.even
_signon::
	.dbline -1
	.dbline 205
; }
; 
; //  Output sign on message loaded from Flash
; void signon()
; {
	.dbline 206
; 	putfs(signon1);
	ldi R16,<_signon1
	ldi R17,>_signon1
	xcall _putfs
	.dbline 207
; 	putfs(signon2);
	ldi R16,<_signon2
	ldi R17,>_signon2
	xcall _putfs
	.dbline 208
; 	putfs(signon3);
	ldi R16,<_signon3
	ldi R17,>_signon3
	xcall _putfs
	.dbline 209
; 	putfs(signon4);
	ldi R16,<_signon4
	ldi R17,>_signon4
	xcall _putfs
	.dbline 210
; 	putfs(signon5);
	ldi R16,<_signon5
	ldi R17,>_signon5
	xcall _putfs
	.dbline 211
; 	putfs(signon6);
	ldi R16,<_signon6
	ldi R17,>_signon6
	xcall _putfs
	.dbline 212
; 	putfs(signon7);
	ldi R16,<_signon7
	ldi R17,>_signon7
	xcall _putfs
	.dbline 213
; 	putfs(signon8);
	ldi R16,<_signon8
	ldi R17,>_signon8
	xcall _putfs
	.dbline 214
; 	putfs(signon83);
	ldi R16,<_signon83
	ldi R17,>_signon83
	xcall _putfs
	.dbline 215
; 	putfs(signon85);
	ldi R16,<_signon85
	ldi R17,>_signon85
	xcall _putfs
	.dbline 216
; 	putfs(signon9);
	ldi R16,<_signon9
	ldi R17,>_signon9
	xcall _putfs
	.dbline -2
L47:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayEEPROM _DisplayEEPROM fV
;       numlines -> y+5
; bytesonlastline -> y+4
;        linecnt -> y+2
;      tempvalue -> R20
;       asciicnt -> y+1
;     newaddress -> R12,R13
;       crcvalue -> y+0
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+17
	.even
_DisplayEEPROM::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,7
	.dbline -1
	.dbline 222
; }
; 
; 
; //  Display AVR EEPROM memory
; void DisplayEEPROM(int address,int numbytes)
; {
	.dbline 226
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+1,R0
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	.dbline 227
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 228
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+6,R17
	std y+5,R16
	.dbline 229
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R10
	sub R2,R16
	sbc R3,R17
	std y+4,R2
	xjmp L50
L49:
	.dbline 230
; 	 while(linecnt<numlines) {
	.dbline 231
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 232
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 233
; 		 PrintHex(bytesonline);		 //  Output bytes on line
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 234
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 236
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 237
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 238
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 239
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 240
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 241
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 243
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L52
	ldi R17,>L52
	xcall _puts
	.dbline 245
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L56
L53:
	.dbline 245
	.dbline 246
; 	         byte = EEPROMread(i+newaddress);
	mov R16,R10
	clr R17
	add R16,R12
	adc R17,R13
	xcall _EEPROMread
	mov R22,R16
	.dbline 247
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+1
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 248
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 249
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 250
; 	         }
L54:
	.dbline 245
	inc R10
L56:
	.dbline 245
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L53
X10:
	.dbline 251
; 		 linecnt++;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 252
; 		 asciicnt = 0;
	clr R0
	std y+1,R0
	.dbline 254
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 255
; 	     puts("  ");
	ldi R16,<L57
	ldi R17,>L57
	xcall _puts
	.dbline 256
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L61
L58:
	.dbline 256
	.dbline 257
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L62
X11:
	mov R24,R14
	cpi R24,128
	brsh L62
X12:
	.dbline 257
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L63
L62:
	.dbline 258
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L63:
	.dbline 259
; 			 }
L59:
	.dbline 256
	inc R10
L61:
	.dbline 256
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L58
X13:
	.dbline 260
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 261
; 		 }
L50:
	.dbline 230
	ldd R0,y+2
	ldd R1,y+3
	ldd R16,y+5
	ldd R17,y+6
	cp R0,R16
	cpc R1,R17
	brge X20
	xjmp L49
X20:
X14:
	.dbline 262
; 	 if(bytesonlastline) {
	ldd R0,y+4
	tst R0
	brne X21
	xjmp L64
X21:
X15:
	.dbline 262
	.dbline 263
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 264
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 266
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	ldd R16,y+4
	xcall _PrintHex
	.dbline 267
; 		 crcvalue += bytesonlastline;
	ldd R0,y+0
	ldd R16,y+4
	add R0,R16
	std y+0,R0
	.dbline 269
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 270
; 	     addresstohex(newaddress);
	movw R16,R12
	xcall _addresstohex
	.dbline 271
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 272
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 273
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 274
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 275
; 	     puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline 277
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L52
	ldi R17,>L52
	xcall _puts
	.dbline 279
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L69
L66:
	.dbline 279
	.dbline 280
; 	         byte = EEPROMread(i+address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	ldd R0,y+17
	ldd R1,y+18
	add R16,R0
	adc R17,R1
	add R16,R2
	adc R17,R3
	xcall _EEPROMread
	mov R20,R16
	mov R22,R20
	.dbline 281
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+1
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 282
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 283
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 284
; 	         }
L67:
	.dbline 279
	inc R10
L69:
	.dbline 279
	ldd R0,y+4
	cp R10,R0
	brlo L66
X16:
	.dbline 286
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 287
; 	     puts("  ");
	ldi R16,<L57
	ldi R17,>L57
	xcall _puts
	.dbline 288
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L73
L70:
	.dbline 288
	.dbline 289
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L74
X17:
	cpi R20,128
	brsh L74
X18:
	.dbline 289
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L75
L74:
	.dbline 290
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L75:
	.dbline 291
; 			 }
L71:
	.dbline 288
	inc R10
L73:
	.dbline 288
	ldd R0,y+4
	cp R10,R0
	brlo L70
X19:
	.dbline 292
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 293
; 		 }
L64:
	.dbline -2
L48:
	.dbline 0 ; func end
	adiw R28,7
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 5 I
	.dbsym l bytesonlastline 4 c
	.dbsym l linecnt 2 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 1 c
	.dbsym r newaddress 12 I
	.dbsym l crcvalue 0 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 17 I
	.dbend
	.dbfunc e DisplayAVRFlash _DisplayAVRFlash fV
;       numlines -> y+3
; bytesonlastline -> R12
;     newaddress -> R20,R21
;      tempvalue -> R10
;       asciicnt -> y+2
;        linecnt -> y+0
;       crcvalue -> R14
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+15
	.even
_DisplayAVRFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,5
	.dbline -1
	.dbline 298
; }
; 
; //  Display P1 AVR Flash memory
; void DisplayAVRFlash(int address,int numbytes)
; {
	.dbline 302
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+2,R0
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 303
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 304
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+4,R17
	std y+3,R16
	.dbline 305
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	mov R12,R10
	sub R12,R16
	sbc R13,R17
	xjmp L78
L77:
	.dbline 306
; 	 while(linecnt<numlines) {
	.dbline 307
; 	 	 crcvalue = 0;
	clr R14
	.dbline 308
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 310
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 311
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R14
	clr R5
	add R4,R2
	adc R5,R3
	mov R14,R4
	.dbline 313
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	ldd R20,y+15
	ldd R21,y+16
	add R20,R16
	adc R21,R17
	.dbline 314
; 	     PrintWordHex(newaddress);
	movw R16,R20
	xcall _PrintWordHex
	.dbline 315
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R24,R20
	andi R24,0
	movw R10,R24
	mov R10,R11
	clr R11
	.dbline 316
; 		 crcvalue += tempvalue;
	add R14,R10
	.dbline 317
; 		 tempvalue = newaddress&0x00ff;
	movw R24,R20
	andi R25,0
	.dbline 318
; 		 crcvalue += tempvalue;
	add R14,R24
	.dbline 320
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L52
	ldi R17,>L52
	xcall _puts
	.dbline 322
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L83
L80:
	.dbline 322
	.dbline 323
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R22,R16
	.dbline 324
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+2
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 325
; 			 crcvalue += byte;
	add R14,R16
	.dbline 326
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 327
; 	         }
L81:
	.dbline 322
	inc R10
L83:
	.dbline 322
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L80
X22:
	.dbline 328
; 		 linecnt++;
	ldd R24,y+0
	ldd R25,y+1
	adiw R24,1
	std y+1,R25
	std y+0,R24
	.dbline 329
; 		 asciicnt = 0;
	clr R0
	std y+2,R0
	.dbline 331
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 332
; 	     puts("  ");
	ldi R16,<L57
	ldi R17,>L57
	xcall _puts
	.dbline 333
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L87
L84:
	.dbline 333
	.dbline 334
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L88
X23:
	cpi R20,128
	brsh L88
X24:
	.dbline 334
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L89
L88:
	.dbline 335
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L89:
	.dbline 336
; 			 }
L85:
	.dbline 333
	inc R10
L87:
	.dbline 333
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L84
X25:
	.dbline 337
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 338
; 		 }
L78:
	.dbline 306
	ldd R0,y+0
	ldd R1,y+1
	ldd R16,y+3
	ldd R17,y+4
	cp R0,R16
	cpc R1,R17
	brge X32
	xjmp L77
X32:
X26:
	.dbline 339
; 	 if(bytesonlastline) {
	tst R12
	brne X33
	xjmp L90
X33:
X27:
	.dbline 339
	.dbline 340
; 	     crcvalue = 0;
	clr R14
	.dbline 341
; 	     putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 343
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	mov R16,R12
	xcall _PrintHex
	.dbline 345
; 	     //  Output hex start address
; 	     PrintWordHex(address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	ldd R16,y+15
	ldd R17,y+16
	add R16,R2
	adc R17,R3
	xcall _PrintWordHex
	.dbline 347
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L52
	ldi R17,>L52
	xcall _puts
	.dbline 349
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L95
L92:
	.dbline 349
	.dbline 350
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R20,R16
	mov R22,R20
	.dbline 351
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+2
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 352
; 			 crcvalue += byte;
	add R14,R16
	.dbline 353
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 354
; 	         }
L93:
	.dbline 349
	inc R10
L95:
	.dbline 349
	cp R10,R12
	brlo L92
X28:
	.dbline 356
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 357
; 	     puts("  ");
	ldi R16,<L57
	ldi R17,>L57
	xcall _puts
	.dbline 358
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L99
L96:
	.dbline 358
	.dbline 359
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L100
X29:
	cpi R20,128
	brsh L100
X30:
	.dbline 359
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	xcall _putcharr
	xjmp L101
L100:
	.dbline 360
; 			 else putcharr('.');
	ldi R16,46
	ldi R17,0
	xcall _putcharr
L101:
	.dbline 361
; 			 }
L97:
	.dbline 358
	inc R10
L99:
	.dbline 358
	cp R10,R12
	brlo L96
X31:
	.dbline 362
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 363
; 		 }
L90:
	.dbline -2
L76:
	.dbline 0 ; func end
	adiw R28,5
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 3 I
	.dbsym r bytesonlastline 12 c
	.dbsym r newaddress 20 I
	.dbsym r tempvalue 10 c
	.dbsym l asciicnt 2 c
	.dbsym l linecnt 0 I
	.dbsym r crcvalue 14 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 15 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 367
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 368
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L105
X34:
	ldi R22,1
	ldi R23,0
	xjmp L106
L105:
	clr R22
	clr R23
L106:
	ldi R24,70
	cp R24,R16
	brlo L107
X35:
	ldi R20,1
	ldi R21,0
	xjmp L108
L107:
	clr R20
	clr R21
L108:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X36
	tst R3
	breq L103
X36:
	.dbline 368
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L102
L103:
	.dbline 369
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L111
X37:
	ldi R22,1
	ldi R23,0
	xjmp L112
L111:
	clr R22
	clr R23
L112:
	ldi R24,102
	cp R24,R16
	brlo L113
X38:
	ldi R20,1
	ldi R21,0
	xjmp L114
L113:
	clr R20
	clr R21
L114:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X39
	tst R3
	breq L109
X39:
	.dbline 369
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L102
L109:
	.dbline 370
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L102:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e ScanHex _ScanHex fi
;        address -> R10,R11
;            len -> R12
;              i -> R20
	.even
_ScanHex::
	xcall push_xgsetF0FC
	.dbline -1
	.dbline 376
; }
; 
; // Read in a hex string and convert to int or long
; //  TBD - add long support for serial flash support
; unsigned int  ScanHex()
; {
	.dbline 378
;  	 unsigned int  address;
;  	 char i=0,len;
	clr R20
	.dbline 380
; 	 
; 	 address = 0;
	clr R10
	clr R11
	.dbline 381
; 	 putcharr((instrg[0]=getcharr()));
	xcall _getcharr
	sts _instrg,R16
	clr R17
	xcall _putcharr
	xjmp L117
L116:
	.dbline 382
;  	 while((instrg[i]!=CR)&&(instrg[i]!=' ')) {
	.dbline 383
; 	 	 i++;
	inc R20
	.dbline 384
; 	     putcharr((instrg[i]=getcharr()));
	xcall _getcharr
	movw R12,R16
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R12
	clr R17
	xcall _putcharr
	.dbline 385
; 		 }
L117:
	.dbline 382
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R22,z+0
	clr R23
	cpi R22,13
	breq L119
X40:
	cpi R22,32
	brne L116
X41:
L119:
	.dbline 386
; 	 instrg[i] = 0;
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 387
; 	 len = strlen(instrg);
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _strlen
	movw R12,R16
	.dbline 388
; 	 address = hextobyte(instrg[len-1]);
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R10,R14
	clr R11
	.dbline 389
; 	 i = 1;
	ldi R20,1
	xjmp L122
L121:
	.dbline 390
; 	 while(i<len) {
	.dbline 391
; 	     if(i==1) address += (hextobyte(instrg[len-i-1])*16);
	cpi R20,1
	brne L124
X42:
	.dbline 391
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	ldi R24,16
	mul R24,R14
	add R10,R0
	adc R11,R1
L124:
	.dbline 392
; 	     if(i==2) address += (hextobyte(instrg[len-i-1])*256);
	cpi R20,2
	brne L127
X43:
	.dbline 392
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	add R10,R16
	adc R11,R17
L127:
	.dbline 393
; 	     if(i==3) address += (hextobyte(instrg[len-i-1])*4096);
	cpi R20,3
	brne L130
X44:
	.dbline 393
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,4096
	ldi R17,16
	xcall empy16s
	add R10,R16
	adc R11,R17
L130:
	.dbline 394
; 		 i++;
	inc R20
	.dbline 395
; 		 }
L122:
	.dbline 390
	cp R20,R12
	brsh X46
	xjmp L121
X46:
X45:
	.dbline 396
; 	 return address;
	movw R16,R10
	.dbline -2
L115:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
	.dbsym r address 10 i
	.dbsym r len 12 c
	.dbsym r i 20 c
	.dbend
	.dbfunc e GetByteHex _GetByteHex fc
;           strg -> y+0
	.even
_GetByteHex::
	st -y,R10
	sbiw R28,3
	.dbline -1
	.dbline 400
; }
; 
; unsigned char GetByteHex()
; {
	.dbline 405
;  	 char strg[3];
; 	 
; //	 putcharr((strg[0]=getchar()));
; //	 putcharr((strg[1]=getchar()));
; 	 strg[0]=getcharr();
	xcall _getcharr
	std y+0,R16
	.dbline 406
; 	 strg[1]=getcharr();
	xcall _getcharr
	std y+1,R16
	.dbline 407
; 	 strg[2] = 0;
	clr R2
	std y+2,R2
	.dbline 408
; 	 return converttohex(strg);
	movw R16,R28
	xcall _converttohex
	mov R10,R16
	.dbline -2
L133:
	.dbline 0 ; func end
	adiw R28,3
	ld R10,y+
	ret
	.dbsym l strg 0 A[3:3]c
	.dbend
	.dbfunc e DisplayMemory _DisplayMemory fV
;         length -> R12,R13
;        address -> R10,R11
;         inchar -> R14
	.even
_DisplayMemory::
	xcall push_xgset30FC
	sbiw R28,1
	.dbline -1
	.dbline 412
; }
; 
; void DisplayMemory(void)
; {
	.dbline 416
;     unsigned char inchar;
; 	unsigned int address, length;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R14,R16
	.dbline 417
; 	putcharr(inchar);
	clr R17
	xcall _putcharr
	.dbline 418
; 	putCRLF();
	xcall _putCRLF
	.dbline 419
; 	putfs(displaymessage1);
	ldi R16,<_displaymessage1
	ldi R17,>_displaymessage1
	xcall _putfs
	.dbline 420
; 	address = ScanHex();
	xcall _ScanHex
	movw R10,R16
	.dbline 421
; 	length = ScanHex();
	xcall _ScanHex
	movw R12,R16
	.dbline 422
; 	putCRLF();
	xcall _putCRLF
	.dbline 423
; 	switch (inchar) {
	mov R20,R14
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L141
X47:
	cpi R20,66
	ldi R30,0
	cpc R21,R30
	breq L143
X48:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L140
X49:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L142
X50:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L137
X51:
L144:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L141
X52:
	cpi R20,98
	ldi R30,0
	cpc R21,R30
	breq L143
X53:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L140
X54:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L142
X55:
	xjmp L137
L140:
	.dbline 425
; 	    case 'e': case 'E':
; 			DisplayEEPROM(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayEEPROM
	.dbline 426
; 		    break;
	xjmp L138
L141:
	.dbline 428
; 		case 'a': case 'A':
; 		    DisplayAVRFlash(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayAVRFlash
	.dbline 429
; 		    break;
	xjmp L138
L142:
	.dbline 435
; 		//  In order to access Blackfin Flash the AVR must ask the Blackfin
; 		//  to release control of the SPI lines.  This is simulated in Rev A
; 		//  boards by resetting the Blackfin (which should release the SPI lines)
; 		//  On completion the AVR SPI lines are released.
; 		case 'f': case 'F':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 436
; 		    DisplaySerialFlash(address,length,READCONTINUOUS);			
	ldi R24,1
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 437
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 438
; 		    break;
	xjmp L138
L143:
	.dbline 440
; 		case 'b': case 'B':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 441
; 		    DisplaySerialFlash(address,length,READBUFFER);				
	ldi R24,2
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 442
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 443
; 		    break;
	xjmp L138
L137:
	.dbline 445
; 		default:
; 		    putfs(displaymessage33);
	ldi R16,<_displaymessage33
	ldi R17,>_displaymessage33
	xcall _putfs
	.dbline 446
; 		    break;
L138:
	.dbline -2
L136:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r length 12 i
	.dbsym r address 10 i
	.dbsym r inchar 14 c
	.dbend
	.dbfunc e checkcrc _checkcrc fI
;        crcbyte -> <dead>
;        cycbyte -> <dead>
	.even
_checkcrc::
	st -y,r17
	st -y,r16
	.dbline -1
	.dbline 453
; 	    }
; }
; 
; 
; // Check intelbinary CRC 
; int checkcrc(unsigned char cycbyte)
; {
	.dbline 456
;  	unsigned char crcbyte;
; 	
; 	GetByteHex();
	xcall _GetByteHex
	.dbline 457
;  	return 1;
	ldi R16,1
	ldi R17,0
	.dbline -2
L145:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l crcbyte 1 c
	.dbsym l cycbyte 0 c
	.dbend
	.dbfunc e DecodeIntelHex _DecodeIntelHex fI
;    addressbyte -> <dead>
;           strg -> y+0
;         inbyte -> R10
;              i -> R20,R21
	.even
_DecodeIntelHex::
	xcall push_xgset303C
	sbiw R28,8
	.dbline -1
	.dbline 472
; }
; 
; // Convert Intel Hex ASCII string to binary
; //
; // :10 0100 00 0C948F0D0C941D0E0C941D0E0C941D0E 38
; // :1001000000C941D0E0C941D0E0C944E590C941D0E38
; // This routine decodes a line of Intel Hex.  Other 
; // routines write the data to either AVR Flash, external Flash
; // or AVR EEPROM
; //
; //   :02 0000 04 0000FA  - IntelHex32 super address record
; // 
; //  TBD - check crc byte - drop record if incorrect
; int DecodeIntelHex(void)
; {
	.dbline 476
;  	 unsigned char strg[8],addressbyte,inbyte;
; 	 int i;
; 	 
; 	 putcharr(':');
	ldi R16,58
	ldi R17,0
	xcall _putcharr
	.dbline 478
; 	 // Convert count of bytes on line
; 	 bytesonline = GetByteHex();
	xcall _GetByteHex
	mov R2,R16
	clr R3
	sts _bytesonline+1,R3
	sts _bytesonline,R2
	.dbline 482
; 	 
; 	 // Convert address to binary - ignore filler byte
; 	 // Typical Intel Hex consists of 4 ASCII characters
; 	 inteladdress = GetByteHex()*256;
	xcall _GetByteHex
	mov R18,R16
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _inteladdress+1,R17
	sts _inteladdress,R16
	.dbline 483
; 	 inteladdress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_inteladdress
	lds R5,_inteladdress+1
	add R4,R2
	adc R5,R3
	sts _inteladdress+1,R5
	sts _inteladdress,R4
	.dbline 486
; 	 
; 	 // Read dump byte (2 characters)
; 	 intelrecordcommand = GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	sts _intelrecordcommand,R12
	.dbline 488
; 	 
; 	 if(intelrecordcommand==0x04) {
	cpi R16,4
	brne L147
X56:
	.dbline 488
	.dbline 489
; 	     intelsuperaddress = GetByteHex()*256;
	xcall _GetByteHex
	mov R12,R16
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _intelsuperaddress+1,R17
	sts _intelsuperaddress,R16
	.dbline 490
; 		 intelsuperaddress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_intelsuperaddress
	lds R5,_intelsuperaddress+1
	add R4,R2
	adc R5,R3
	sts _intelsuperaddress+1,R5
	sts _intelsuperaddress,R4
	.dbline 491
; 		 }
	xjmp L148
L147:
	.dbline 492
; 	 else  {
	.dbline 494
; 	     // Convert all data to binary
; 	     for(i=0; i<bytesonline; i++) {
	clr R20
	clr R21
	xjmp L152
L149:
	.dbline 494
	.dbline 495
; 		     inbyte = GetByteHex(strg);
	movw R16,R28
	xcall _GetByteHex
	mov R12,R16
	mov R10,R12
	.dbline 496
; 		     intelbinary[i] = inbyte;
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	movw R30,R20
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 497
; 	 	     }
L150:
	.dbline 494
	subi R20,255  ; offset = 1
	sbci R21,255
L152:
	.dbline 494
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	cp R20,R2
	cpc R21,R3
	brlo L149
X57:
	.dbline 498
; 		 }
L148:
	.dbline 501
; 		 
; 	// Check CRC - todo
; 	if(checkcrc(inbyte)) return 1;
	mov R16,R10
	xcall _checkcrc
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L153
X58:
	.dbline 501
	ldi R16,1
	ldi R17,0
	xjmp L146
L153:
	.dbline 502
; 	else return -1;
	ldi R16,-1
	ldi R17,-1
	.dbline -2
L146:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgset303C
	.dbsym l addressbyte 1 c
	.dbsym l strg 0 A[8:8]c
	.dbsym r inbyte 10 c
	.dbsym r i 20 I
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 508
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 509
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L156
X59:
	ldi R16,1
	ldi R17,0
	xjmp L157
L156:
	clr R16
	clr R17
L157:
	.dbline -2
L155:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramEEPROM _ProgramEEPROM fV
;              i -> R10
	.even
_ProgramEEPROM::
	st -y,R10
	.dbline -1
	.dbline 514
; }
; 
; //  Write decoded Intel hex to EEPROM
; void ProgramEEPROM(void)
; {
	.dbline 517
;      unsigned char i;
; 	 
; 	 for(i=0; i<bytesonline; i++)  EEPROMWrite(inteladdress+i,intelbinary[i]);
	clr R10
	xjmp L162
L159:
	.dbline 517
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R2,R10
	clr R3
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	add R16,R2
	adc R17,R3
	xcall _EEPROMWrite
L160:
	.dbline 517
	inc R10
L162:
	.dbline 517
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L159
X60:
	.dbline -2
L158:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r i 10 c
	.dbend
	.dbfunc e ProgramAVRFlash _ProgramAVRFlash fV
;         inchar -> R10
	.even
_ProgramAVRFlash::
	st -y,R10
	.dbline -1
	.dbline 522
; }
; 
; //  TBD - AVR Flash hold program so programming AVR flash may overwrite program
; void ProgramAVRFlash(void)
; {
	xjmp L165
L164:
	.dbline 525
;  	 char inchar;
; 	 
;  	 while((inchar=getcharr())!=CR) putcharr(inchar);
	mov R16,R10
	clr R17
	xcall _putcharr
L165:
	.dbline 525
	xcall _getcharr
	mov R10,R16
	cpi R16,13
	brne L164
X61:
	.dbline 526
; 	 printf("\n-");
	ldi R16,<L167
	ldi R17,>L167
	xcall _printf
	.dbline -2
L163:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e CleanUpFlashState _CleanUpFlashState fV
	.even
_CleanUpFlashState::
	.dbline -1
	.dbline 530
; }
; 
; void CleanUpFlashState()
; {
	.dbline 531
; 	if(flashdatainbuffer==YES)  {
	lds R24,_flashdatainbuffer
	cpi R24,1
	brne L169
X62:
	.dbline 531
	.dbline 532
; 	    inteladdress = oldinteladdress;  // end of file record destroyed intelad
	lds R2,_oldinteladdress
	lds R3,_oldinteladdress+1
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	.dbline 533
; 	    ProgramBuffertoPageErase(1);
	ldi R16,1
	xcall _ProgramBuffertoPageErase
	.dbline 534
; 		WaitForFlashFree(1);
	ldi R16,1
	ldi R17,0
	xcall _WaitForFlashFree
	.dbline 535
; 		}
L169:
	.dbline 536
; 	if(flashprogrammingactive==YES)  {
	lds R24,_flashprogrammingactive
	cpi R24,1
	brne L171
X63:
	.dbline 536
	.dbline 537
; 		Release_SPI();
	xcall _Release_SPI
	.dbline 538
; 		flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 539
; 		flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 540
; 		flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 541
; 		flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 542
; 		}
L171:
	.dbline -2
L168:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramMemory _ProgramMemory fV
	.even
_ProgramMemory::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 554
; }
; 
; //  Main memory programming selection function
; //  Program EEPROM, AVR Flash or SPI Flash.
; //  Three IntelHex32 Records 0x00, 0x01 and 0x04 are processed by this
; //  routine.  0x00 is a data record, 0x01 is End of File record and 
; //  0x04 is extended address record
; //
; //  TBD - no intel record time out - reset defaults if not intel 
; //        records received after 3 seconds
; void ProgramMemory(void)
; {
	.dbline 555
;  	DecodeIntelHex();
	xcall _DecodeIntelHex
	.dbline 556
; 	switch (programmode) {
	lds R20,_programmode
	clr R21
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L180
X64:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L177
X65:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L183
X66:
	xjmp L174
L177:
	.dbline 558
; 	    case LEEPROM:
; 			if(intelrecordcommand==0) ProgramEEPROM();
	lds R2,_intelrecordcommand
	tst R2
	brne L175
X67:
	.dbline 558
	xcall _ProgramEEPROM
	.dbline 559
; 			break;
	xjmp L175
L180:
	.dbline 561
; 		case LAVRFLASH:
; 		    if(intelrecordcommand==0) ProgramAVRFlash();
	lds R2,_intelrecordcommand
	tst R2
	brne L175
X68:
	.dbline 561
	xcall _ProgramAVRFlash
	.dbline 562
; 			break;
	xjmp L175
L183:
	.dbline 575
; 			
; 		//  To access Blackfin Flash the Blackfin must not have control 
; 		//  of the shared SPI lines and the Blackfin reset line must not
; 		//  be active.  The Blackfin releases control of the SPI lines under 
; 		//  software control or by being forced to boot mode 0.  If the Blackfin
; 		//  is reset to boot mode 3 it will attempt to load a program from 
; 		//  serial flash preventing the AVR from accessing the serial flash.
; 		
; 		//  This implementation forces the Blackfin to reboot.
; 		//  Cooperative flash access still TBD
; 		case LFLASH:
; 		    // Data record			
; 			if(intelrecordcommand==0) {
	lds R2,_intelrecordcommand
	tst R2
	brne L184
X69:
	.dbline 575
	.dbline 576
; 			    flashcountdown = 3000;  // 3 second no new Hex record timeout
	ldi R24,3000
	ldi R25,11
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
	.dbline 578
; 			    //  See is SPI Master is active - set active if not
; 			    if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L186
X70:
	.dbline 578
	.dbline 579
; 				    Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 580
; 					}
L186:
	.dbline 582
; 					
; 		        ProgramSerialFlash();		
	xcall _ProgramSerialFlash
	.dbline 583
; 				}
	xjmp L175
L184:
	.dbline 585
; 			// Extended address record
; 			else if(intelrecordcommand==0x04) ; // nothing to do
	lds R24,_intelrecordcommand
	cpi R24,4
	brne L188
X71:
	.dbline 585
	xjmp L175
L188:
	.dbline 588
; 			
; 			// End of File record - reset all variables
; 			else if(intelrecordcommand==0x01) CleanUpFlashState();
	lds R24,_intelrecordcommand
	cpi R24,1
	brne L175
X72:
	.dbline 588
	xcall _CleanUpFlashState
	.dbline 589
; 			break;
L174:
L175:
	.dbline -2
L173:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbend
	.dbfunc e LoadMemory _LoadMemory fV
;         inchar -> R10
	.even
_LoadMemory::
	xcall push_xgset300C
	.dbline -1
	.dbline 596
; 		} 
; }
; 
; //  Set default memory programming mode
; //  Subsequent Intel Hex dumps will load to the specific memory
; void LoadMemory(void)
; {
	.dbline 599
;     unsigned char inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R10,R16
	.dbline 600
; 	putcharr(inchar);
	clr R17
	xcall _putcharr
	.dbline 601
; 	switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L198
X73:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L196
X74:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L197
X75:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L194
X76:
L199:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L198
X77:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L196
X78:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L197
X79:
	xjmp L194
L196:
	.dbline 603
; 	    case 'e': case 'E':
; 			programmode = LEEPROM;
	ldi R24,101
	sts _programmode,R24
	.dbline 604
; 			putfs(loadmessage1);
	ldi R16,<_loadmessage1
	ldi R17,>_loadmessage1
	xcall _putfs
	.dbline 605
; 		    break;
	xjmp L194
L197:
	.dbline 607
; 		case 'f': case 'F':
; 			programmode = LFLASH;
	ldi R24,102
	sts _programmode,R24
	.dbline 608
; 			putfs(loadmessage2);
	ldi R16,<_loadmessage2
	ldi R17,>_loadmessage2
	xcall _putfs
	.dbline 609
; 		    break;
	xjmp L194
L198:
	.dbline 611
; 		case 'a': case 'A':
; 			programmode = LAVRFLASH;
	ldi R24,97
	sts _programmode,R24
	.dbline 612
; 		    putfs(loadmessage3);
	ldi R16,<_loadmessage3
	ldi R17,>_loadmessage3
	xcall _putfs
	.dbline 613
; 		    break;
	.dbline 615
; 		default:
; 		   break;
L194:
	.dbline -2
L192:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.area lit(rom, con, rel)
L201:
	.byte 48,46,56,53,0
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
	.dbfunc e ProgramVersion _ProgramVersion fV
;        version -> y+0
	.even
_ProgramVersion::
	sbiw R28,5
	.dbline -1
	.dbline 622
; 	    }
; }
; 
; //  Output program version
; //   TBD - read from EEPROM
; void ProgramVersion(void)
; {
	.dbline 623
;       char version[5]="0.85";
	ldi R24,<L201
	ldi R25,>L201
	movw R30,R28
	ldi R16,5
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 625
; 	  
; 	  putfs(progmessage);
	ldi R16,<_progmessage
	ldi R17,>_progmessage
	xcall _putfs
	.dbline 626
; 	  puts(version);
	movw R16,R28
	xcall _puts
	.dbline 627
; 	  putCRLF();
	xcall _putCRLF
	.dbline -2
L200:
	.dbline 0 ; func end
	adiw R28,5
	ret
	.dbsym l version 0 A[5:5]c
	.dbend
	.dbfunc e AnalogCh _AnalogCh fI
;           high -> R12
;            low -> R10
;           mode -> R20
;             ch -> R22,R23
	.even
_AnalogCh::
	xcall push_xgsetF03C
	mov R20,R18
	movw R22,R16
	.dbline -1
	.dbline 633
; }
; 
; //  Read selected analog channel - wait until it completes
; //   TBD - background interrupt process
; int AnalogCh(int ch,char mode)
; {
	.dbline 636
;  	unsigned char low,high;
; 	
; 	if(ch==0) ADMUX = 0x00;  
	cpi R22,0
	cpc R22,R23
	brne L203
X80:
	.dbline 636
	clr R2
	sts 124,R2
	xjmp L204
L203:
	.dbline 637
; 	else if(ch==1) ADMUX = 0x01; 
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brne L205
X81:
	.dbline 637
	ldi R24,1
	sts 124,R24
	xjmp L206
L205:
	.dbline 638
; 	else if(ch==2) ADMUX = 0x02;
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	brne L207
X82:
	.dbline 638
	ldi R24,2
	sts 124,R24
	xjmp L208
L207:
	.dbline 639
; 	else if(ch==3) ADMUX = 0x03;
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	brne L209
X83:
	.dbline 639
	ldi R24,3
	sts 124,R24
	xjmp L210
L209:
	.dbline 640
; 	else if(ch==4) ADMUX = 0x04; 
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	brne L211
X84:
	.dbline 640
	ldi R24,4
	sts 124,R24
	xjmp L212
L211:
	.dbline 641
; 	else if(ch==5) ADMUX = 0x05;
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	brne L213
X85:
	.dbline 641
	ldi R24,5
	sts 124,R24
	xjmp L214
L213:
	.dbline 642
; 	else if(ch==6) ADMUX = 0x06;
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	brne L215
X86:
	.dbline 642
	ldi R24,6
	sts 124,R24
	xjmp L216
L215:
	.dbline 643
; 	else if(ch==7) ADMUX = 0x07;
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne L217
X87:
	.dbline 643
	ldi R24,7
	sts 124,R24
L217:
L216:
L214:
L212:
L210:
L208:
L206:
L204:
	.dbline 645
; 	
; 	if(mode==INTERNALREF)  ADMUX |= 0xC0;//2.56v
	cpi R20,105
	brne L219
X88:
	.dbline 645
	lds R24,124
	ori R24,192
	sts 124,R24
	xjmp L220
L219:
	.dbline 646
; 	else ADMUX |= 0x40;  // use AVCC
	lds R24,124
	ori R24,64
	sts 124,R24
L220:
	.dbline 648
; 	
; 	ADCSRA = (1<<ADEN)|(1<<ADSC)|0x06; // Enable ADC, start conversion, max clock
	ldi R24,198
	sts 122,R24
L221:
	.dbline 653
; 	
; 	
; 	//while(!(ADCSRA&(1<<ADIF))) ; // loop until conversion completes
; 	
; 	while((ADCSRA&(1<<ADSC)));
L222:
	.dbline 653
	lds R2,122
	sbrc R2,6
	rjmp L221
X89:
	.dbline 655
; 	
; 	shortdelay(10);
	ldi R16,10
	ldi R17,0
	xcall _shortdelay
	.dbline 657
; 	
; 	low = ADCL;
	lds R10,120
	.dbline 658
; 	high = ADCH;
	lds R12,121
	.dbline 659
; 	return (low + (high*256));
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L202:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r mode 20 c
	.dbsym r ch 22 I
	.dbend
	.dbfunc e DumpAnalogChs _DumpAnalogChs fV
;    analogvalue -> R10,R11
;              i -> R20,R21
	.even
_DumpAnalogChs::
	xcall push_xgset300C
	.dbline -1
	.dbline 663
; }
; 
; void DumpAnalogChs(void)
; {
	.dbline 666
;     int  i,analogvalue;
; 	
; 	printf("Analog Channels 0..7\n");
	ldi R16,<L225
	ldi R17,>L225
	xcall _printf
	.dbline 667
;  	for(i=0; i<8; i++) {
	clr R20
	clr R21
L226:
	.dbline 667
	.dbline 668
; 	    analogvalue = AnalogCh(i,EXTERNALREF);
	ldi R18,101
	movw R16,R20
	xcall _AnalogCh
	movw R10,R16
	.dbline 669
; 		printf("%d ",analogvalue);
	movw R18,R10
	ldi R16,<L230
	ldi R17,>L230
	xcall _printf
	.dbline 670
; 		} 
L227:
	.dbline 667
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 667
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L226
X90:
	.dbline 671
; 	printf("\n"); 
	ldi R16,<L231
	ldi R17,>L231
	xcall _printf
	.dbline -2
L224:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r analogvalue 10 I
	.dbsym r i 20 I
	.dbend
	.dbfunc e getint _getint fc
;       intvalue -> R20
;         inchar -> R22
	.even
_getint::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 675
; }
; 
; char getint()
; {
	.dbline 678
; 	char intvalue,inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 679
; 	putcharr(inchar);
	clr R17
	xcall _putcharr
	.dbline 680
; 	if(inchar==CR) return 0x78;
	cpi R22,13
	brne L233
X91:
	.dbline 680
	ldi R16,120
	xjmp L232
L233:
	.dbline 681
; 	intvalue = (inchar - '0')*10;
	ldi R24,10
	mul R24,R22
	mov R20,R0
	subi R20,224
	.dbline 682
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 683
; 	putcharr(inchar);	
	clr R17
	xcall _putcharr
	.dbline 684
; 	intvalue = intvalue + (inchar-'0');
	mov R24,R22
	subi R24,48
	add R20,R24
	.dbline 685
; 	return intvalue;
	mov R16,R20
	.dbline -2
L232:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r intvalue 20 c
	.dbsym r inchar 22 c
	.dbend
	.dbfunc e getsettime _getsettime fV
;         inchar -> R10
;         instrg -> y+6
	.even
_getsettime::
	xcall push_xgset003C
	sbiw R28,10
	.dbline -1
	.dbline 690
; }
; 
; // Update the current day and time
; void  getsettime()
; {
	.dbline 693
;     unsigned char instrg[4],inchar;
; 	
;     _CLI();
	cli
	.dbline 694
; 	instrg[0] = days;
	lds R2,_days
	std y+6,R2
	.dbline 695
; 	instrg[1] = hours;
	lds R2,_hours
	std y+7,R2
	.dbline 696
; 	instrg[2] = minutes;
	lds R2,_minutes
	std y+8,R2
	.dbline 697
; 	instrg[3] = seconds;
	lds R2,_seconds
	std y+9,R2
	.dbline 698
; 	_SEI();	
	sei
	.dbline 700
; 	
; 	printf("Set time [hh:mm:ss]=%d %d:%d:%d :",
	clr R3
	std y+5,R3
	std y+4,R2
	ldd R2,y+8
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+7
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+6
	clr R19
	ldi R16,<L239
	ldi R17,>L239
	xcall _printf
	.dbline 703
; 	   		instrg[0],instrg[1],instrg[2],instrg[3]);
; 
; 	if((instrg[1]=getint())==0x78) return;
	xcall _getint
	std y+7,R16
	cpi R16,120
	brne L243
X92:
	.dbline 703
	xjmp L235
L243:
	.dbline 704
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 704
	clr R17
	xcall _putcharr
	.dbline 705
; 	instrg[2] = getint();
	xcall _getint
	mov R12,R16
	std y+8,R12
	.dbline 706
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 706
	clr R17
	xcall _putcharr
	.dbline 707
; 	instrg[3] = getint();
	xcall _getint
	mov R12,R16
	std y+9,R12
	.dbline 708
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	movw R12,R16
	mov R10,R12
	.dbline 708
	clr R17
	xcall _putcharr
	.dbline 710
; 
;     _CLI();
	cli
	.dbline 711
; 	hours = instrg[1];
	ldd R2,y+7
	sts _hours,R2
	.dbline 712
; 	minutes = instrg[2];
	ldd R2,y+8
	sts _minutes,R2
	.dbline 713
; 	seconds = instrg[3];
	ldd R2,y+9
	sts _seconds,R2
	.dbline 714
; 	_SEI();	
	sei
	.dbline -2
L235:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgset003C
	.dbsym r inchar 10 c
	.dbsym l instrg 6 A[4:4]c
	.dbend
	.dbfunc e TestAVR _TestAVR fV
;              j -> R20
;              i -> R22
	.even
_TestAVR::
	xcall push_xgsetF000
	.dbline -1
	.dbline 719
; }
; 
; //  Simple test routine
; void TestAVR(void)
; {
	.dbline 722
;  	 char i,j;
; 	 
;  	 printf("\nTesting AVR Version 0.34\n");
	ldi R16,<L252
	ldi R17,>L252
	xcall _printf
	.dbline 727
; //	 TestAVRRAM();
; //	 TestAVREEPROM();
; //	 TestAVRFLASH();
; //	 TestBoardFLASH():
; 	 j = 0;
	clr R20
	.dbline 728
; 	 putcharr(' ');
	ldi R16,32
	ldi R17,0
	xcall _putcharr
	.dbline 729
; 	 for(i=0x20; i<0x7f; i++) {
	ldi R22,32
	xjmp L256
L253:
	.dbline 729
	.dbline 730
; 	 	 putcharr(i);
	mov R16,R22
	clr R17
	xcall _putcharr
	.dbline 731
; 		 if(j++ == 60)  {
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R24,R2
	cpi R24,60
	brne L257
X93:
	.dbline 731
	.dbline 732
; 		     j = 0;
	clr R20
	.dbline 733
; 			 printf("\n ");
	ldi R16,<L259
	ldi R17,>L259
	xcall _printf
	.dbline 734
; 			 }
L257:
	.dbline 735
; 		 }
L254:
	.dbline 729
	inc R22
L256:
	.dbline 729
	cpi R22,127
	brlo L253
X94:
	.dbline 736
; 	 printf("\n ");
	ldi R16,<L259
	ldi R17,>L259
	xcall _printf
	.dbline 737
; 	 DumpAnalogChs();
	xcall _DumpAnalogChs
	.dbline -2
L251:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r j 20 c
	.dbsym r i 22 c
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L259:
	.blkb 3
	.area idata
	.byte 10,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L252:
	.blkb 27
	.area idata
	.byte 10,'T,'e,'s,'t,'i,'n,'g,32,'A,'V,'R,32,'V,'e,'r
	.byte 's,'i,'o,'n,32,48,46,51,52,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L239:
	.blkb 34
	.area idata
	.byte 'S,'e,'t,32,'t,'i,'m,'e,32,91,'h,'h,58,'m,'m,58
	.byte 's,'s,93,61,37,'d,32,37,'d,58,37,'d,58,37,'d,32
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L231:
	.blkb 2
	.area idata
	.byte 10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L230:
	.blkb 4
	.area idata
	.byte 37,'d,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L225:
	.blkb 22
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,32,'C,'h,'a,'n,'n,'e,'l,'s,32
	.byte 48,46,46,55,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L167:
	.blkb 3
	.area idata
	.byte 10,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L57:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
L52:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\WASPBI~1\Wasp_Utilities.c
; }
; 
